#!/usr/bin/perl
use strict;
use warnings;

use XML::Simple;
use Data::Dumper;


my $xml = new XML::Simple;
my $data = $xml->XMLin("Corpus.xml");

#Argumentuak: bertsolari kopurua eta bertsoen kopurua
die("Programak 2 argumentu behar ditu\n") if ($#ARGV != 1);

#Idazketarako helburu fitxategia ireki
open(FITXOUT1, ">Test.xml") or die("Ezin da Test.xml sortu!\n");
open(FITXOUT2, ">Develop.xml") or die("Ezin da Develop.xml sortu!\n");
open(FITXOUT3, ">Train.xml") or die("Ezin da Train.xml sortu!\n");



#////////////////////////////////////////////////////////////////
#TRAIN-DEVELOP-TEST BANAKETA
#////////////////////////////////////////////////////////////////

my $bertso_kop = $ARGV[1];
my $test_develop_bertsoak = int(($bertso_kop*10/100)+0.5);
my $train_bertsoak = $bertso_kop-(2*$test_develop_bertsoak);
my $n = $ARGV[0];

print (FITXOUT1 "<?xml version='1.0' encoding='ISO-8859-1'?>\n\n");
print (FITXOUT2 "<?xml version='1.0' encoding='ISO-8859-1'?>\n\n");
print (FITXOUT3 "<?xml version='1.0' encoding='ISO-8859-1'?>\n\n");

print (FITXOUT1 "<Bertsoak>\n\n");
print (FITXOUT2 "<Bertsoak>\n\n");
print (FITXOUT3 "<Bertsoak>\n\n");

my (@hh, @hh2, @hh3, @bb, @bb2, @bb3);
my ($b, $h);


for (my $i = 1; $i <= $n; $i++)
{
    my @bertsoa_erabilita = (0) x ($bertso_kop+1);
    
    
    #TEST
    $b=0;
    $h=0;
    
    print (FITXOUT1 "<Bertsolaria id=\"$i\">\n");
    print (FITXOUT1 "\t<Izena>$data->{Bertsolaria}->{$i}->{Izena}</Izena>\n");
    print (FITXOUT1 "\t<Transkripzioa>\n");
    
    while ($b<$test_develop_bertsoak){
        
        my $ausaz_bertsoa = int(rand($bertso_kop));
        my $bertso_zenbakia=0;
        
        if (ref($data->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}) eq 'ARRAY'){
            foreach my $lerroak (@{$data->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}}){
                $bertso_zenbakia++;
                if ($bertso_zenbakia == $ausaz_bertsoa && $bertsoa_erabilita[$bertso_zenbakia]!=1){
                    $bertsoa_erabilita[$bertso_zenbakia]=1;
                    $b++;
                    print (FITXOUT1 "\t\t<lg>\n");
                    foreach my $lerro (@{$lerroak->{l}}){
                        print (FITXOUT1 "\t\t\t<l>\n");
                        if (ref($lerro->{w}) eq 'ARRAY'){
                            foreach my $hitz (@{$lerro->{w}}){
                                $h++;
                                print (FITXOUT1 XMLout($hitz,RootName=>"w"));
                            }
                        }else{
                            $h++;
                            print (FITXOUT1 XMLout($lerro->{w},RootName=>"w"));
                        }
                        print (FITXOUT1 "\t\t\t</l>\n");
                    }
                    print (FITXOUT1 "\t\t</lg>\n");
                }
            }
        }else{
            $bertso_zenbakia++;
            if ($bertso_zenbakia == $ausaz_bertsoa && $bertsoa_erabilita[$bertso_zenbakia]!=1){
                $bertsoa_erabilita[$bertso_zenbakia]=1;
                $b++;
                print (FITXOUT1 "\t\t<lg>\n");
                foreach my $lerro (@{$data->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}->{l}}){
                    print (FITXOUT1 "\t\t\t<l>\n");
                    if (ref($lerro->{w}) eq 'ARRAY'){
                        foreach my $hitz (@{$lerro->{w}}){
                            $h++;
                            print (FITXOUT1 XMLout($hitz,RootName=>"w"));
                        }
                    }else{
                        $h++;
                        print (FITXOUT1 XMLout($lerro->{w},RootName=>"w"));
                    }
                    print (FITXOUT1 "\t\t\t</l>\n");
                }
            print (FITXOUT1 "\t\t</lg>\n");
            }
        }
        
        
    }
    print (FITXOUT1 "\t</Transkripzioa>\n");
    print (FITXOUT1 "</Bertsolaria>\n\n\n\n\n");

    $hh[$i] = $h;
    $bb[$i] = $b;

    
    
    #DEVELOP
    
    $b=0;
    $h=0;
    
    print (FITXOUT2 "<Bertsolaria id=\"$i\">\n");
    print (FITXOUT2 "\t<Izena>$data->{Bertsolaria}->{$i}->{Izena}</Izena>\n");
    print (FITXOUT2 "\t<Transkripzioa>\n");
    
    while ($b<$test_develop_bertsoak){
        
        my $ausaz_bertsoa = int(rand($bertso_kop));
        my $bertso_zenbakia=0;
        
        if (ref($data->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}) eq 'ARRAY'){
            foreach my $lerroak (@{$data->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}}){
                $bertso_zenbakia++;
                if ($bertso_zenbakia == $ausaz_bertsoa && $bertsoa_erabilita[$bertso_zenbakia]!=1){
                    $bertsoa_erabilita[$bertso_zenbakia]=1;
                    $b++;
                    print (FITXOUT2 "\t\t<lg>\n");
                    foreach my $lerro (@{$lerroak->{l}}){
                        print (FITXOUT2 "\t\t\t<l>\n");
                        if (ref($lerro->{w}) eq 'ARRAY'){
                            foreach my $hitz (@{$lerro->{w}}){
                                $h++;
                                print (FITXOUT2 XMLout($hitz,RootName=>"w"));
                            }
                        }else{
                            $h++;
                            print (FITXOUT2 XMLout($lerro->{w},RootName=>"w"));
                        }
                        print (FITXOUT2 "\t\t\t</l>\n");
                    }
                    print (FITXOUT2 "\t\t</lg>\n");
                }
            }
        }else{
            $bertso_zenbakia++;
            if ($bertso_zenbakia == $ausaz_bertsoa && $bertsoa_erabilita[$bertso_zenbakia]!=1){
                $bertsoa_erabilita[$bertso_zenbakia]=1;
                $b++;
                print (FITXOUT2 "\t\t<lg>\n");
                foreach my $lerro (@{$data->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}->{l}}){
                    print (FITXOUT2 "\t\t\t<l>\n");
                    if (ref($lerro->{w}) eq 'ARRAY'){
                        foreach my $hitz (@{$lerro->{w}}){
                            $h++;
                            print (FITXOUT2 XMLout($hitz,RootName=>"w"));
                        }
                    }else{
                        $h++;
                        print (FITXOUT2 XMLout($lerro->{w},RootName=>"w"));
                    }
                    print (FITXOUT2 "\t\t\t</l>\n");
                }
                print (FITXOUT2 "\t\t</lg>\n");
            }
        }
        
        
    }
    print (FITXOUT2 "\t</Transkripzioa>\n");
    print (FITXOUT2 "</Bertsolaria>\n\n\n\n\n");
    
    $hh2[$i] = $h;
    $bb2[$i] = $b;

    
    #TRAIN
    
    $b=0;
    $h=0;
    
    print (FITXOUT3 "<Bertsolaria id=\"$i\">\n");
    print (FITXOUT3 "\t<Izena>$data->{Bertsolaria}->{$i}->{Izena}</Izena>\n");
    print (FITXOUT3 "\t<Transkripzioa>\n");
    
    my $bertso_zenbakia=0;
    
    if (ref($data->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}) eq 'ARRAY'){
        foreach my $lerroak (@{$data->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}}){
            $bertso_zenbakia++;
            if ($bertsoa_erabilita[$bertso_zenbakia]!=1){
                $bertsoa_erabilita[$bertso_zenbakia]=1;
                $b++;
                print (FITXOUT3 "\t\t<lg>\n");
                foreach my $lerro (@{$lerroak->{l}}){
                    print (FITXOUT3 "\t\t\t<l>\n");
                    if (ref($lerro->{w}) eq 'ARRAY'){
                        foreach my $hitz (@{$lerro->{w}}){
                            $h++;
                            print (FITXOUT3 XMLout($hitz,RootName=>"w"));
                        }
                    }else{
                        $h++;
                        print (FITXOUT3 XMLout($lerro->{w},RootName=>"w"));
                    }
                    print (FITXOUT3 "\t\t\t</l>\n");
                }
                print (FITXOUT3 "\t\t</lg>\n");
            }
        }
    }else{
        $bertso_zenbakia++;
        if ($bertsoa_erabilita[$bertso_zenbakia]!=1){
            $bertsoa_erabilita[$bertso_zenbakia]=1;
            $b++;
            print (FITXOUT3 "\t\t<lg>\n");
            foreach my $lerro (@{$data->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}->{l}}){
                print (FITXOUT3 "\t\t\t<l>\n");
                if (ref($lerro->{w}) eq 'ARRAY'){
                    foreach my $hitz (@{$lerro->{w}}){
                        $h++;
                        print (FITXOUT3 XMLout($hitz,RootName=>"w"));
                    }
                }else{
                    $h++;
                    print (FITXOUT3 XMLout($lerro->{w},RootName=>"w"));
                }
                print (FITXOUT3 "\t\t\t</l>\n");
            }
            print (FITXOUT3 "\t\t</lg>\n");
        }
    }

    
    print (FITXOUT3 "\t</Transkripzioa>\n");
    print (FITXOUT3 "</Bertsolaria>\n\n\n\n\n");
    
    $hh3[$i] = $h;
    $bb3[$i] = $b;

}

print (FITXOUT1 "</Bertsoak>");
print (FITXOUT2 "</Bertsoak>");
print (FITXOUT3 "</Bertsoak>");


print " TEST / DEVELOP / TRAIN    (token-bertso) \n";
print "-------------------------------------------------\n";
for (my $i = 1; $i <= $n; $i++)
{
    print "$hh[$i] - $bb[$i] / $hh2[$i] - $bb2[$i] / $hh3[$i] - $bb3[$i] \n";
}


#Fitxategiak itxi
close(FITXOUT1);
close(FITXOUT2);
close(FITXOUT3);

