#!/usr/bin/perl
use strict;
use warnings;

use XML::Simple;
use Data::Dumper;

#Argumentuak: bertsolari kopurua, CW kopurua eta hitz ez-estandarren kopurua
die("Programak 3 argumentu behar ditu\n") if ($#ARGV != 2);

#Euskarazko CW-ak irakurri
open(FITXIN, "content-words.txt") or die("Ezin da content-words.txt zabaldu!\n");

my (@hitzak, $lerro, %CWda, @h);

my $j=0;

while ($lerro = <FITXIN>)
{
    chomp($lerro);
    @h = split " ", $lerro;
    if(!exists($CWda{$h[0]})){
        $CWda{$h[0]}=1;
        $hitzak[$j]=$h[0];
        $j++;
    }
}
delete($CWda{"sar"});



my $xml = new XML::Simple;

my $data1 = $xml->XMLin("Test.xml");
my $data2 = $xml->XMLin("Develop.xml");
my $data3 = $xml->XMLin("Train.xml");


my $n = $ARGV[0];#bertsolari kopurua
my (%EzEstandar, %EzEsAukeratuak, %CW, %CWaukeratuak);


for (my $i = 1; $i <= $n; $i++)
{
    #CW-ak eskuratu: lehenengo hitza CW den ikusi eta ez bada lema
    #Hitz ez-estandarrak eskuratu: ez-estandarra bada hitza hartu
    foreach my $bertso (@{$data1->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{ezest} eq '1'){
                    $EzEstandar{$lerro->{w}->{content}}++;
                }
                if ($CWda{$lerro->{w}->{content}}){
                    $CW{$lerro->{w}->{content}}++;
                }else{
                    if ($CWda{$lerro->{w}->{lemma}}){
                        $CW{$lerro->{w}->{lemma}}++;
                    }
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($hitz->{ezest} eq '1'){
                        $EzEstandar{$hitz->{content}}++;
                    }
                    if ($CWda{$hitz->{content}}){
                        $CW{$hitz->{content}}++;
                    }else{
                        if ($CWda{$hitz->{lemma}}){
                            $CW{$hitz->{lemma}}++;
                        }
                    }
                }
            }
        }
    }
    foreach my $bertso (@{$data2->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{ezest} eq '1'){
                    $EzEstandar{$lerro->{w}->{content}}++;
                }
                if ($CWda{$lerro->{w}->{content}}){
                    $CW{$lerro->{w}->{content}}++;
                }else{
                    if ($CWda{$lerro->{w}->{lemma}}){
                        $CW{$lerro->{w}->{lemma}}++;
                    }
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($hitz->{ezest} eq '1'){
                        $EzEstandar{$hitz->{content}}++;
                    }
                    if ($CWda{$hitz->{content}}){
                        $CW{$hitz->{content}}++;
                    }else{
                        if ($CWda{$hitz->{lemma}}){
                            $CW{$hitz->{lemma}}++;
                        }
                    }
                }
            }
        }
    }
    foreach my $bertso (@{$data3->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{ezest} eq '1'){
                    $EzEstandar{$lerro->{w}->{content}}++;
                }
                if ($CWda{$lerro->{w}->{content}}){
                    $CW{$lerro->{w}->{content}}++;
                }else{
                    if ($CWda{$lerro->{w}->{lemma}}){
                        $CW{$lerro->{w}->{lemma}}++;
                    }
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($hitz->{ezest} eq '1'){
                        $EzEstandar{$hitz->{content}}++;
                    }
                    if ($CWda{$hitz->{content}}){
                        $CW{$hitz->{content}}++;
                    }else{
                        if ($CWda{$hitz->{lemma}}){
                            $CW{$hitz->{lemma}}++;
                        }
                    }
                }
            }
        }
    }
}

my $kop = 0;
my @hitzakezes;
my $i = 0;
my $ezeskop = $ARGV[2];#hitz ez-estandarren kopurua



foreach my $auk (sort { $EzEstandar{$b} <=>  $EzEstandar{$a} } keys %EzEstandar){
    if ($auk !~ m/(\.|,|;|:|!|\?|\"|\')/){#puntuazio ikurrak kentzeko
        if ($kop<$ezeskop){
            $EzEsAukeratuak{$auk} = 1;
            $hitzakezes[$i]=$auk;
            $i++;
        }
        $kop++;
    }
}

$kop = 0;
my $cw_kop = $ARGV[1];#CW kopurua

foreach my $auk (sort { $CW{$b} <=>  $CW{$a} } keys %CW){
    if ($kop<$cw_kop and !exists($EzEsAukeratuak{$auk})){
        $CWaukeratuak{$auk} = 1;
    }
    $kop++;
}


#ARFF sortu

open(FITXOUT1, ">$cw_kop-cw-$ezeskop-ezes_test.arff") or die("Ezin da $cw_kop-cw-$ezeskop-ezes_test.arff fitxategia sortu\n");
open(FITXOUT2, ">$cw_kop-cw-$ezeskop-ezes_develop.arff") or die("Ezin da $cw_kop-cw-$ezeskop-ezes_develop.arff fitxategia sortu\n");
open(FITXOUT3, ">$cw_kop-cw-$ezeskop-ezes_train.arff") or die("Ezin da $cw_kop-cw-$ezeskop-ezes_train.arff fitxategia sortu\n");


print (FITXOUT1 "\@relation CW-$cw_kop-EzEstandarrak-$ezeskop\n\n");
print (FITXOUT2 "\@relation CW-$cw_kop-EzEstandarrak-$ezeskop\n\n");
print (FITXOUT3 "\@relation CW-$cw_kop-EzEstandarrak-$ezeskop\n\n");

foreach my $hitz (@hitzak)
{
    if (exists($CWaukeratuak{$hitz})){
        print (FITXOUT1 "\@attribute $hitz real\n");
        print (FITXOUT2 "\@attribute $hitz real\n");
        print (FITXOUT3 "\@attribute $hitz real\n");
    }
}

foreach my $hitz (@hitzakezes)
{
    print (FITXOUT1 "\@attribute $hitz real\n");
    print (FITXOUT2 "\@attribute $hitz real\n");
    print (FITXOUT3 "\@attribute $hitz real\n");
}


print (FITXOUT1 "\@attribute bertsolaria {");
print (FITXOUT2 "\@attribute bertsolaria {");
print (FITXOUT3 "\@attribute bertsolaria {");

for (my $i = 1; $i <= $n; $i++)
{
    print (FITXOUT1 "$data1->{Bertsolaria}->{$i}->{Izena}");
    print (FITXOUT2 "$data2->{Bertsolaria}->{$i}->{Izena}");
    print (FITXOUT3 "$data3->{Bertsolaria}->{$i}->{Izena}");

    if ($i < $n){
        print (FITXOUT1 ",");
        print (FITXOUT2 ",");
        print (FITXOUT3 ",");
    }
}

print (FITXOUT1 "}\n\n");
print (FITXOUT2 "}\n\n");
print (FITXOUT3 "}\n\n");
print (FITXOUT1 "\@data\n");
print (FITXOUT2 "\@data\n");
print (FITXOUT3 "\@data\n");


for (my $i = 1; $i <= $n; $i++)
{
    
    #CW-ak eskuratu: lehenengo hitza CW den ikusi eta ez bada lema
    #Hitz ez-estandarrak eskuratu: ez-estandarra bada hitza hartu
    #Bertso bakoitzean hitz kopuruko erabilitako CW-ak eta hitz ez-estandarrak kalkulatzen dira
    foreach my $bertso (@{$data1->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %EzEs = ();
        my %CW = ();
        my $kont = 0;
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if (exists($EzEsAukeratuak{$lerro->{w}->{content}}) and $lerro->{w}->{ezest} eq '1'){
                    $EzEs{$lerro->{w}->{content}}++;
                }
                if (exists($CWaukeratuak{$lerro->{w}->{content}})){
                    $CW{$lerro->{w}->{content}}++;
                }else{
                    if (exists($CWaukeratuak{$lerro->{w}->{lemma}})){
                        $CW{$lerro->{w}->{lemma}}++;
                    }
                }
                $kont++;
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if (exists($EzEsAukeratuak{$hitz->{content}}) and $hitz->{ezest} eq '1'){
                        $EzEs{$hitz->{content}}++;
                    }
                    if (exists($CWaukeratuak{$hitz->{content}})){
                        $CW{$hitz->{content}}++;
                    }else{
                        if (exists($CWaukeratuak{$hitz->{lemma}})){
                            $CW{$hitz->{lemma}}++;
                        }
                    }
                    $kont++;
                }
            }
        }

        
        foreach my $hitz (@hitzak){
            if (exists($CWaukeratuak{$hitz})){
                if (exists($CW{$hitz})){
                    $CW{$hitz} = sprintf("%.2f", ($CW{$hitz} / $kont) * 100);
                }else{
                    $CW{$hitz} = 0;
                }
                print (FITXOUT1 "$CW{$hitz},");
            }
        }
        
        foreach my $hitz (@hitzakezes){
            if (exists($EzEs{$hitz})){
                $EzEs{$hitz} = sprintf("%.2f", ($EzEs{$hitz} / $kont) * 100);
            }else{
                $EzEs{$hitz} = 0;
            }
            print (FITXOUT1 "$EzEs{$hitz},");
        }
        print (FITXOUT1 "$data1->{Bertsolaria}->{$i}->{Izena}\n");
        
    }
    
    foreach my $bertso (@{$data2->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %EzEs = ();
        my %CW = ();
        my $kont = 0;
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if (exists($EzEsAukeratuak{$lerro->{w}->{content}}) and $lerro->{w}->{ezest} eq '1'){
                    $EzEs{$lerro->{w}->{content}}++;
                }
                if (exists($CWaukeratuak{$lerro->{w}->{content}})){
                    $CW{$lerro->{w}->{content}}++;
                }else{
                    if (exists($CWaukeratuak{$lerro->{w}->{lemma}})){
                        $CW{$lerro->{w}->{lemma}}++;
                    }
                }
                $kont++;
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if (exists($EzEsAukeratuak{$hitz->{content}}) and $hitz->{ezest} eq '1'){
                        $EzEs{$hitz->{content}}++;
                    }
                    if (exists($CWaukeratuak{$hitz->{content}})){
                        $CW{$hitz->{content}}++;
                    }else{
                        if (exists($CWaukeratuak{$hitz->{lemma}})){
                            $CW{$hitz->{lemma}}++;
                        }
                    }
                    $kont++;
                }
            }
        }
        
        
        foreach my $hitz (@hitzak){
            if (exists($CWaukeratuak{$hitz})){
                if (exists($CW{$hitz})){
                    $CW{$hitz} = sprintf("%.2f", ($CW{$hitz} / $kont) * 100);
                }else{
                    $CW{$hitz} = 0;
                }
                print (FITXOUT2 "$CW{$hitz},");
            }
        }
        
        
        foreach my $hitz (@hitzakezes){
            if (exists($EzEs{$hitz})){
                $EzEs{$hitz} = sprintf("%.2f", ($EzEs{$hitz} / $kont) * 100);
            }else{
                $EzEs{$hitz} = 0;
            }
            print (FITXOUT2 "$EzEs{$hitz},");
        }
        print (FITXOUT2 "$data2->{Bertsolaria}->{$i}->{Izena}\n");
        
    }
        

    
    foreach my $bertso (@{$data3->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %EzEs = ();
        my %CW = ();
        my $kont = 0;
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if (exists($EzEsAukeratuak{$lerro->{w}->{content}}) and $lerro->{w}->{ezest} eq '1'){
                    $EzEs{$lerro->{w}->{content}}++;
                }
                if (exists($CWaukeratuak{$lerro->{w}->{content}})){
                    $CW{$lerro->{w}->{content}}++;
                }else{
                    if (exists($CWaukeratuak{$lerro->{w}->{lemma}})){
                        $CW{$lerro->{w}->{lemma}}++;
                    }
                }
                $kont++;
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if (exists($EzEsAukeratuak{$hitz->{content}}) and $hitz->{ezest} eq '1'){
                        $EzEs{$hitz->{content}}++;
                    }
                    if (exists($CWaukeratuak{$hitz->{content}})){
                        $CW{$hitz->{content}}++;
                    }else{
                        if (exists($CWaukeratuak{$hitz->{lemma}})){
                            $CW{$hitz->{lemma}}++;
                        }
                    }
                    $kont++;
                }
            }
        }
        
        
        
        foreach my $hitz (@hitzak){
            if (exists($CWaukeratuak{$hitz})){
                if (exists($CW{$hitz})){
                    $CW{$hitz} = sprintf("%.2f", ($CW{$hitz} / $kont) * 100);
                }else{
                    $CW{$hitz} = 0;
                }
                print (FITXOUT3 "$CW{$hitz},");
            }
        }
        
        foreach my $hitz (@hitzakezes){
            if (exists($EzEs{$hitz})){
                $EzEs{$hitz} = sprintf("%.2f", ($EzEs{$hitz} / $kont) * 100);
            }else{
                $EzEs{$hitz} = 0;
            }
            print (FITXOUT3 "$EzEs{$hitz},");
        }
        print (FITXOUT3 "$data3->{Bertsolaria}->{$i}->{Izena}\n");
        
    }
}

close(FITXOUT1);
close(FITXOUT2);
close(FITXOUT3);
