#!/usr/bin/perl
use strict;
use warnings;
use FileHandle;
use IPC::Open2;
use locale;


use XML::Simple;
use Data::Dumper;

die("Programak argumentu bat behar du\n") if ($#ARGV != 0);


my $xml = new XML::Simple;

my $data1 = $xml->XMLin("Test.xml");
my $data2 = $xml->XMLin("Develop.xml");
my $data3 = $xml->XMLin("Train.xml");


my $n = $ARGV[0];#bertsolari kopurua
my ($oina, $hitza, %ErrimaDa);
my $pidFOMA = open2(*Reader, *Writer, "flookup -i -x -b errimaPatroia.fst");#errimak lortzeko automata


#Errimak eskuratu
for (my $i = 1; $i <= $n; $i++)
{
    foreach my $bertso (@{$data1->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %errimak_bertsoko = ();
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{content} =~ m/\w/){
                    $hitza = $lerro->{w}->{content};
                    $hitza =~ s/[\.,;:!\?\"\']//;
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($hitz->{content} =~ m/\w/){
                        $hitza = $hitz->{content};
                        $hitza =~ s/[\.,;:!\?\"\']//;
                    }
                }
            }
            $oina = $hitza;
            $errimak_bertsoko{errima_atera($oina)}++;
        }
        
        #gehien errepikatzen dena da bertsoko errima
        my @err = sort{$errimak_bertsoko{$b} <=> $errimak_bertsoko{$a}} keys(%errimak_bertsoko);
        $ErrimaDa{$err[0]}=1;
    }
    
    foreach my $bertso (@{$data2->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %errimak_bertsoko = ();
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{content} =~ m/\w/){
                    $hitza = $lerro->{w}->{content};
                    $hitza =~ s/[\.,;:!\?\"\']//;
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($hitz->{content} =~ m/\w/){
                        $hitza = $hitz->{content};
                        $hitza =~ s/[\.,;:!\?\"\']//;
                    }
                }
            }
            $oina = $hitza;
            $errimak_bertsoko{errima_atera($oina)}++;
        }
        
        #gehien errepikatzen dena da bertsoko errima
        my @err = sort{$errimak_bertsoko{$b} <=> $errimak_bertsoko{$a}} keys(%errimak_bertsoko);
        $ErrimaDa{$err[0]}=1;
    }
    
    foreach my $bertso (@{$data3->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %errimak_bertsoko = ();
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{content} =~ m/\w/){
                    $hitza = $lerro->{w}->{content};
                    $hitza =~ s/[\.,;:!\?\"\']//;
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($hitz->{content} =~ m/\w/){
                        $hitza = $hitz->{content};
                        $hitza =~ s/[\.,;:!\?\"\']//;
                    }
                }
            }
            $oina = $hitza;
            $errimak_bertsoko{errima_atera($oina)}++;
        }
        
        #gehien errepikatzen dena da bertsoko errima
        my @err = sort{$errimak_bertsoko{$b} <=> $errimak_bertsoko{$a}} keys(%errimak_bertsoko);
        $ErrimaDa{$err[0]}=1;
    }
}


my @Errimak = sort{$ErrimaDa{$b} <=> $ErrimaDa{$a}} keys(%ErrimaDa);




#ARFF sortu

open(FITXOUT1, ">errimak_test.arff") or die("Ezin da errimak_test.arff fitxategia sortu\n");
open(FITXOUT2, ">errimak_develop.arff") or die("Ezin da errimak_develop.arff fitxategia sortu\n");
open(FITXOUT3, ">errimak_train.arff") or die("Ezin da errimak_train.arff fitxategia sortu\n");


print (FITXOUT1 "\@relation EzEstandarrak\n\n");
print (FITXOUT2 "\@relation EzEstandarrak\n\n");
print (FITXOUT3 "\@relation EzEstandarrak\n\n");


foreach my $e (@Errimak)
{
    print (FITXOUT1 "\@attribute $e {0,1}\n");
    print (FITXOUT2 "\@attribute $e {0,1}\n");
    print (FITXOUT3 "\@attribute $e {0,1}\n");
}


print (FITXOUT1 "\@attribute bertsolaria {");
print (FITXOUT2 "\@attribute bertsolaria {");
print (FITXOUT3 "\@attribute bertsolaria {");


for (my $i = 1; $i <= $n; $i++)
{
    print (FITXOUT1 "$data1->{Bertsolaria}->{$i}->{Izena}");
    print (FITXOUT2 "$data2->{Bertsolaria}->{$i}->{Izena}");
    print (FITXOUT3 "$data3->{Bertsolaria}->{$i}->{Izena}");
    
    if ($i < $n){
        print (FITXOUT1 ",");
        print (FITXOUT2 ",");
        print (FITXOUT3 ",");
    }
}

print (FITXOUT1 "}\n\n");
print (FITXOUT2 "}\n\n");
print (FITXOUT3 "}\n\n");
print (FITXOUT1 "\@data\n");
print (FITXOUT2 "\@data\n");
print (FITXOUT3 "\@data\n");


for (my $i = 1; $i <= $n; $i++)
{
    
    #Errimak eskuratu
    foreach my $bertso (@{$data1->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %errimak_bertsoko = ();
        my ($errima, $hitza, $oina);
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{content} =~ m/\w/){
                    $hitza = $lerro->{w}->{content};
                    $hitza =~ s/[\.,;:!\?\"\']//;
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($hitz->{content} =~ m/\w/){
                        $hitza = $hitz->{content};
                        $hitza =~ s/[\.,;:!\?\"\']//;
                    }
                }
            }
            $oina = $hitza;
            $errimak_bertsoko{errima_atera($oina)}++;
        }
        
        #gehien errepikatzen dena da bertsoko errima
        my @err = sort{$errimak_bertsoko{$b} <=> $errimak_bertsoko{$a}} keys(%errimak_bertsoko);
        $errima = $err[0];
        
        
        foreach my $e (@Errimak){
            if ($e eq $errima){
                print (FITXOUT1 "1,");
            }else{
                print (FITXOUT1 "0,");
            }
        }
        print (FITXOUT1 "$data1->{Bertsolaria}->{$i}->{Izena}\n");
        
    }
    
    foreach my $bertso (@{$data2->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %errimak_bertsoko = ();
        my ($errima, $hitza, $oina);
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{content} =~ m/\w/){
                    $hitza = $lerro->{w}->{content};
                    $hitza =~ s/[\.,;:!\?\"\']//;
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($hitz->{content} =~ m/\w/){
                        $hitza = $hitz->{content};
                        $hitza =~ s/[\.,;:!\?\"\']//;
                    }
                }
            }
            $oina = $hitza;
            $errimak_bertsoko{errima_atera($oina)}++;
        }
        
        #gehien errepikatzen dena da bertsoko errima
        my @err = sort{$errimak_bertsoko{$b} <=> $errimak_bertsoko{$a}} keys(%errimak_bertsoko);
        $errima = $err[0];
        
        
        foreach my $e (@Errimak){
            if ($e eq $errima){
                print (FITXOUT2 "1,");
            }else{
                print (FITXOUT2 "0,");
            }
        }
        print (FITXOUT2 "$data2->{Bertsolaria}->{$i}->{Izena}\n");
        
    }
    
    
    
    foreach my $bertso (@{$data3->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %errimak_bertsoko = ();
        my ($errima, $hitza, $oina);
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{content} =~ m/\w/){
                    $hitza = $lerro->{w}->{content};
                    $hitza =~ s/[\.,;:!\?\"\']//;
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($hitz->{content} =~ m/\w/){
                        $hitza = $hitz->{content};
                        $hitza =~ s/[\.,;:!\?\"\']//;
                    }
                }
            }
            $oina = $hitza;
            $errimak_bertsoko{errima_atera($oina)}++;
        }
        
        #gehien errepikatzen dena da bertsoko errima
        my @err = sort{$errimak_bertsoko{$b} <=> $errimak_bertsoko{$a}} keys(%errimak_bertsoko);
        $errima = $err[0];
        
        
        foreach my $e (@Errimak){
            if ($e eq $errima){
                print (FITXOUT3 "1,");
            }else{
                print (FITXOUT3 "0,");
            }
        }
        print (FITXOUT3 "$data3->{Bertsolaria}->{$i}->{Izena}\n");
        
    }
}

close(FITXOUT1);
close(FITXOUT2);
close(FITXOUT3);
close(Reader); close(Writer);




#oina emanda errima ateratzeko funtzioa
sub errima_atera {
    
    my $sarrera = shift();
    $sarrera = $sarrera."\n";
    
    print Writer $sarrera;
    
    my ($luz, $luzeena);
    $luz = 0;
    
    while ((my $returnword = <Reader>) ne "\n") {
        chomp($returnword);
        if ($luz < length ($returnword)) {
            $luz = length ($returnword);
            $luzeena = $returnword;
        }
    }
    
    return $luzeena;
}






