#!/usr/bin/perl
use strict;
use warnings;

use XML::Simple;
use Data::Dumper;

#Argumentuak: bertsolari kopurua, FW kopurua eta CW kopurua
die("Programak 3 argumentu behar ditu\n") if ($#ARGV != 2);

#Euskarazko CW eta FW-ak irakurri
open(FITXIN1, "funtzio-hitzakOna.txt") or die("Ezin da funtzio-hitzakOna.txt zabaldu!\n");
open(FITXIN2, "content-words.txt") or die("Ezin da content-words.txt zabaldu!\n");

my (@hitzakFW, @hitzakCW, $lerro, %FWda, %CWda, @h);


my $j=0;

while ($lerro = <FITXIN1>)
{
    chomp($lerro);
    @h = split " ", $lerro;
    if(!exists($FWda{$h[0]})){
        $FWda{$h[0]}=1;
        $hitzakFW[$j]=$h[0];
        $j++;
    }
}
delete($FWda{"sar"});

$j=0;

while ($lerro = <FITXIN2>)
{
    chomp($lerro);
    @h = split " ", $lerro;
    if(!exists($CWda{$h[0]}) and !exists($FWda{$h[0]})){
        $CWda{$h[0]}=1;
        $hitzakCW[$j]=$h[0];
        $j++;
    }
}
delete($CWda{"sar"});


my $xml = new XML::Simple;

my $data1 = $xml->XMLin("Test.xml");
my $data2 = $xml->XMLin("Develop.xml");
my $data3 = $xml->XMLin("Train.xml");


my $n = $ARGV[0];#bertsolari kopurua
my (%FW, %FWaukeratuak, %CW, %CWaukeratuak);


for (my $i = 1; $i <= $n; $i++)
{
    #CW-ak eskuratu: lehenengo hitza CW den ikusi eta ez bada lema
    #FW-ak eskuratu: lehenengo hitza FW den ikusi eta ez bada lema
    foreach my $bertso (@{$data1->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($FWda{$lerro->{w}->{content}}){
                    $FW{$lerro->{w}->{content}}++;
                }else{
                    if ($FWda{$lerro->{w}->{lemma}}){
                        $FW{$lerro->{w}->{lemma}}++;
                    }
                }
                if ($CWda{$lerro->{w}->{content}}){
                    $CW{$lerro->{w}->{content}}++;
                }else{
                    if ($CWda{$lerro->{w}->{lemma}}){
                        $CW{$lerro->{w}->{lemma}}++;
                    }
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($FWda{$hitz->{content}}){
                        $FW{$hitz->{content}}++;
                    }else{
                        if ($FWda{$hitz->{lemma}}){
                            $FW{$hitz->{lemma}}++;
                        }
                    }
                    if ($CWda{$hitz->{content}}){
                        $CW{$hitz->{content}}++;
                    }else{
                        if ($CWda{$hitz->{lemma}}){
                            $CW{$hitz->{lemma}}++;
                        }
                    }
                }
            }
        }
    }
    foreach my $bertso (@{$data2->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($FWda{$lerro->{w}->{content}}){
                    $FW{$lerro->{w}->{content}}++;
                }else{
                    if ($FWda{$lerro->{w}->{lemma}}){
                        $FW{$lerro->{w}->{lemma}}++;
                    }
                }
                if ($CWda{$lerro->{w}->{content}}){
                    $CW{$lerro->{w}->{content}}++;
                }else{
                    if ($CWda{$lerro->{w}->{lemma}}){
                        $CW{$lerro->{w}->{lemma}}++;
                    }
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($FWda{$hitz->{content}}){
                        $FW{$hitz->{content}}++;
                    }else{
                        if ($FWda{$hitz->{lemma}}){
                            $FW{$hitz->{lemma}}++;
                        }
                    }
                    if ($CWda{$hitz->{content}}){
                        $CW{$hitz->{content}}++;
                    }else{
                        if ($CWda{$hitz->{lemma}}){
                            $CW{$hitz->{lemma}}++;
                        }
                    }
                }
            }
        }
    }
    foreach my $bertso (@{$data3->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($FWda{$lerro->{w}->{content}}){
                    $FW{$lerro->{w}->{content}}++;
                }else{
                    if ($FWda{$lerro->{w}->{lemma}}){
                        $FW{$lerro->{w}->{lemma}}++;
                    }
                }
                if ($CWda{$lerro->{w}->{content}}){
                    $CW{$lerro->{w}->{content}}++;
                }else{
                    if ($CWda{$lerro->{w}->{lemma}}){
                        $CW{$lerro->{w}->{lemma}}++;
                    }
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($FWda{$hitz->{content}}){
                        $FW{$hitz->{content}}++;
                    }else{
                        if ($FWda{$hitz->{lemma}}){
                            $FW{$hitz->{lemma}}++;
                        }
                    }
                    if ($CWda{$hitz->{content}}){
                        $CW{$hitz->{content}}++;
                    }else{
                        if ($CWda{$hitz->{lemma}}){
                            $CW{$hitz->{lemma}}++;
                        }
                    }
                }
            }
        }
    }
}

my $kop = 0;
my $fw_kop = $ARGV[1];#FW kopurua

foreach my $auk (sort { $FW{$b} <=>  $FW{$a} } keys %FW){
    if ($kop<$fw_kop){
        $FWaukeratuak{$auk} = 1;
    }
    $kop++;
}

$kop = 0;
my $cw_kop = $ARGV[2];#CW kopurua

foreach my $auk (sort { $CW{$b} <=>  $CW{$a} } keys %CW){
    if ($kop<$cw_kop){
        $CWaukeratuak{$auk} = 1;
    }
    $kop++;
}


#ARFF sortu

open(FITXOUT1, ">$fw_kop-fw-$cw_kop-cw_test.arff") or die("Ezin da $fw_kop-fw-$cw_kop-cw_test.arff fitxategia sortu\n");
open(FITXOUT2, ">$fw_kop-fw-$cw_kop-cw_develop.arff") or die("Ezin da $fw_kop-fw-$cw_kop-cw_develop.arff fitxategia sortu\n");
open(FITXOUT3, ">$fw_kop-fw-$cw_kop-cw_train.arff") or die("Ezin da $fw_kop-fw-$cw_kop-cw_train.arff fitxategia sortu\n");


print (FITXOUT1 "\@relation $fw_kop-FW-eta-$cw_kop-CW\n\n");
print (FITXOUT2 "\@relation $fw_kop-FW-eta-$cw_kop-CW\n\n");
print (FITXOUT3 "\@relation $fw_kop-FW-eta-$cw_kop-CW\n\n");


foreach my $hitz (@hitzakFW)
{
    if (exists($FWaukeratuak{$hitz})){
        print (FITXOUT1 "\@attribute $hitz real\n");
        print (FITXOUT2 "\@attribute $hitz real\n");
        print (FITXOUT3 "\@attribute $hitz real\n");
    }
}

foreach my $hitz (@hitzakCW)
{
    if (exists($CWaukeratuak{$hitz})){
        print (FITXOUT1 "\@attribute $hitz real\n");
        print (FITXOUT2 "\@attribute $hitz real\n");
        print (FITXOUT3 "\@attribute $hitz real\n");
    }
}


print (FITXOUT1 "\@attribute bertsolaria {");
print (FITXOUT2 "\@attribute bertsolaria {");
print (FITXOUT3 "\@attribute bertsolaria {");

for (my $i = 1; $i <= $n; $i++)
{
    print (FITXOUT1 "$data1->{Bertsolaria}->{$i}->{Izena}");
    print (FITXOUT2 "$data2->{Bertsolaria}->{$i}->{Izena}");
    print (FITXOUT3 "$data3->{Bertsolaria}->{$i}->{Izena}");

    if ($i < $n){
        print (FITXOUT1 ",");
        print (FITXOUT2 ",");
        print (FITXOUT3 ",");
    }
}

print (FITXOUT1 "}\n\n");
print (FITXOUT2 "}\n\n");
print (FITXOUT3 "}\n\n");
print (FITXOUT1 "\@data\n");
print (FITXOUT2 "\@data\n");
print (FITXOUT3 "\@data\n");


for (my $i = 1; $i <= $n; $i++)
{
    
    #CW-ak eskuratu: lehenengo hitza CW den ikusi eta ez bada lema
    #FW-ak eskuratu: lehenengo hitza FW den ikusi eta ez bada lema
    #Bertso bakoitzean hitz kopuruko erabilitako CW-ak eta FW-ak kalkulatzen dira
    foreach my $bertso (@{$data1->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %CW = ();
        my %FW = ();
        my $kont = 0;
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if (exists($FWaukeratuak{$lerro->{w}->{content}})){
                    $FW{$lerro->{w}->{content}}++;
                }else{
                    if (exists($FWaukeratuak{$lerro->{w}->{lemma}})){
                        $FW{$lerro->{w}->{lemma}}++;
                    }
                }
                if (exists($CWaukeratuak{$lerro->{w}->{content}})){
                    $CW{$lerro->{w}->{content}}++;
                }else{
                    if (exists($CWaukeratuak{$lerro->{w}->{lemma}})){
                        $CW{$lerro->{w}->{lemma}}++;
                    }
                }
                $kont++;
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if (exists($FWaukeratuak{$hitz->{content}})){
                        $FW{$hitz->{content}}++;
                    }else{
                        if (exists($FWaukeratuak{$hitz->{lemma}})){
                            $FW{$hitz->{lemma}}++;
                        }
                    }
                    if (exists($CWaukeratuak{$hitz->{content}})){
                        $CW{$hitz->{content}}++;
                    }else{
                        if (exists($CWaukeratuak{$hitz->{lemma}})){
                            $CW{$hitz->{lemma}}++;
                        }
                    }
                    $kont++;
                }
            }
        }

        
        foreach my $hitz (@hitzakFW){
            if (exists($FWaukeratuak{$hitz})){
                if (exists($FW{$hitz})){
                    $FW{$hitz} = sprintf("%.2f", ($FW{$hitz} / $kont) * 100);
                }else{
                    $FW{$hitz} = 0;
                }
                print (FITXOUT1 "$FW{$hitz},");
            }
        }

        
        foreach my $hitz (@hitzakCW){
            if (exists($CWaukeratuak{$hitz})){
                if (exists($CW{$hitz})){
                    $CW{$hitz} = sprintf("%.2f", ($CW{$hitz} / $kont) * 100);
                }else{
                    $CW{$hitz} = 0;
                }
                print (FITXOUT1 "$CW{$hitz},");
            }
        }
        print (FITXOUT1 "$data1->{Bertsolaria}->{$i}->{Izena}\n");
        
    }
    
    foreach my $bertso (@{$data2->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %CW = ();
        my %FW = ();
        my $kont = 0;
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if (exists($FWaukeratuak{$lerro->{w}->{content}})){
                    $FW{$lerro->{w}->{content}}++;
                }else{
                    if (exists($FWaukeratuak{$lerro->{w}->{lemma}})){
                        $FW{$lerro->{w}->{lemma}}++;
                    }
                }
                if (exists($CWaukeratuak{$lerro->{w}->{content}})){
                    $CW{$lerro->{w}->{content}}++;
                }else{
                    if (exists($CWaukeratuak{$lerro->{w}->{lemma}})){
                        $CW{$lerro->{w}->{lemma}}++;
                    }
                }
                $kont++;
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if (exists($FWaukeratuak{$hitz->{content}})){
                        $FW{$hitz->{content}}++;
                    }else{
                        if (exists($FWaukeratuak{$hitz->{lemma}})){
                            $FW{$hitz->{lemma}}++;
                        }
                    }
                    if (exists($CWaukeratuak{$hitz->{content}})){
                        $CW{$hitz->{content}}++;
                    }else{
                        if (exists($CWaukeratuak{$hitz->{lemma}})){
                            $CW{$hitz->{lemma}}++;
                        }
                    }
                    $kont++;
                }
            }
        }
        
        foreach my $hitz (@hitzakFW){
            if (exists($FWaukeratuak{$hitz})){
                if (exists($FW{$hitz})){
                    $FW{$hitz} = sprintf("%.2f", ($FW{$hitz} / $kont) * 100);
                }else{
                    $FW{$hitz} = 0;
                }
                print (FITXOUT2 "$FW{$hitz},");
            }
        }
        
        foreach my $hitz (@hitzakCW){
            if (exists($CWaukeratuak{$hitz})){
                if (exists($CW{$hitz})){
                    $CW{$hitz} = sprintf("%.2f", ($CW{$hitz} / $kont) * 100);
                }else{
                    $CW{$hitz} = 0;
                }
                print (FITXOUT2 "$CW{$hitz},");
            }
        }
        print (FITXOUT2 "$data2->{Bertsolaria}->{$i}->{Izena}\n");
        
    }
    
    foreach my $bertso (@{$data3->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %CW = ();
        my %FW = ();
        my $kont = 0;
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if (exists($FWaukeratuak{$lerro->{w}->{content}})){
                    $FW{$lerro->{w}->{content}}++;
                }else{
                    if (exists($FWaukeratuak{$lerro->{w}->{lemma}})){
                        $FW{$lerro->{w}->{lemma}}++;
                    }
                }
                if (exists($CWaukeratuak{$lerro->{w}->{content}})){
                    $CW{$lerro->{w}->{content}}++;
                }else{
                    if (exists($CWaukeratuak{$lerro->{w}->{lemma}})){
                        $CW{$lerro->{w}->{lemma}}++;
                    }
                }
                $kont++;
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if (exists($FWaukeratuak{$hitz->{content}})){
                        $FW{$hitz->{content}}++;
                    }else{
                        if (exists($FWaukeratuak{$hitz->{lemma}})){
                            $FW{$hitz->{lemma}}++;
                        }
                    }
                    if (exists($CWaukeratuak{$hitz->{content}})){
                        $CW{$hitz->{content}}++;
                    }else{
                        if (exists($CWaukeratuak{$hitz->{lemma}})){
                            $CW{$hitz->{lemma}}++;
                        }
                    }
                    $kont++;
                }
            }
        }
        
        foreach my $hitz (@hitzakFW){
            if (exists($FWaukeratuak{$hitz})){
                if (exists($FW{$hitz})){
                    $FW{$hitz} = sprintf("%.2f", ($FW{$hitz} / $kont) * 100);
                }else{
                    $FW{$hitz} = 0;
                }
                print (FITXOUT3 "$FW{$hitz},");
            }
        }
        
        foreach my $hitz (@hitzakCW){
            if (exists($CWaukeratuak{$hitz})){
                if (exists($CW{$hitz})){
                    $CW{$hitz} = sprintf("%.2f", ($CW{$hitz} / $kont) * 100);
                }else{
                    $CW{$hitz} = 0;
                }
                print (FITXOUT3 "$CW{$hitz},");
            }
        }
        print (FITXOUT3 "$data3->{Bertsolaria}->{$i}->{Izena}\n");
        
    }

}

close(FITXOUT1);
close(FITXOUT2);
close(FITXOUT3);
