#!/usr/bin/perl
use strict;
use warnings;

use XML::Simple;
use Data::Dumper;
use Text::Ngram qw(ngram_counts add_to_counts);

my $xml = new XML::Simple;

#Argumentuak: bertsolari kopurua, FW kopurua eta n-ren balioa
die("Programak 3 argumentu behar ditu\n") if ($#ARGV != 2);

#Euskarazko FW-ak irakurri
open(FITXIN, "funtzio-hitzakOna.txt") or die("Ezin da funtzio-hitzakOna.txt zabaldu!\n");

my (@hitzak, $lerro, %FWda, @h);

my $j=0;

while ($lerro = <FITXIN>)
{
    chomp($lerro);
    @h = split " ", $lerro;
    if(!exists($FWda{$h[0]})){
        $FWda{$h[0]}=1;
        $hitzak[$j]=$h[0];
        $j++;
    }
}
delete($FWda{"sar"});


my $data1 = $xml->XMLin("Test.xml");
my $data2 = $xml->XMLin("Develop.xml");
my $data3 = $xml->XMLin("Train.xml");

my $ngrama_kopurua = $ARGV[2];#n-ren balioa
my $n = $ARGV[0];#bertsolari kopurua
my $bertso_guztiak = "";
my (%FW, %FWaukeratuak);


for (my $i = 1; $i <= $n; $i++)
{
    #FW-ak eskuratu: lehenengo hitza FW den ikusi eta ez bada lema
    #Bertso guztiak eskuratu
    foreach my $bertso (@{$data1->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                $bertso_guztiak = $bertso_guztiak . " " . $lerro->{w}->{content};
                if ($FWda{$lerro->{w}->{content}}){
                    $FW{$lerro->{w}->{content}}++;
                }else{
                    if ($FWda{$lerro->{w}->{lemma}}){
                        $FW{$lerro->{w}->{lemma}}++;
                    }
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    $bertso_guztiak = $bertso_guztiak . " " . $hitz->{content};
                    if ($FWda{$hitz->{content}}){
                        $FW{$hitz->{content}}++;
                    }else{
                        if ($FWda{$hitz->{lemma}}){
                            $FW{$hitz->{lemma}}++;
                        }
                    }
                }
            }
            $bertso_guztiak = $bertso_guztiak . "\n";
        }
    }
    foreach my $bertso (@{$data2->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                $bertso_guztiak = $bertso_guztiak . " " . $lerro->{w}->{content};
                if ($FWda{$lerro->{w}->{content}}){
                    $FW{$lerro->{w}->{content}}++;
                }else{
                    if ($FWda{$lerro->{w}->{lemma}}){
                        $FW{$lerro->{w}->{lemma}}++;
                    }
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    $bertso_guztiak = $bertso_guztiak . " " . $hitz->{content};
                    if ($FWda{$hitz->{content}}){
                        $FW{$hitz->{content}}++;
                    }else{
                        if ($FWda{$hitz->{lemma}}){
                            $FW{$hitz->{lemma}}++;
                        }
                    }
                }
            }
            $bertso_guztiak = $bertso_guztiak . "\n";
        }
    }
    foreach my $bertso (@{$data3->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                $bertso_guztiak = $bertso_guztiak . " " . $lerro->{w}->{content};
                if ($FWda{$lerro->{w}->{content}}){
                    $FW{$lerro->{w}->{content}}++;
                }else{
                    if ($FWda{$lerro->{w}->{lemma}}){
                        $FW{$lerro->{w}->{lemma}}++;
                    }
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    $bertso_guztiak = $bertso_guztiak . " " . $hitz->{content};
                    if ($FWda{$hitz->{content}}){
                        $FW{$hitz->{content}}++;
                    }else{
                        if ($FWda{$hitz->{lemma}}){
                            $FW{$hitz->{lemma}}++;
                        }
                    }
                }
            }
            $bertso_guztiak = $bertso_guztiak . "\n";
        }
    }
}

#N-gramak eskuratu
my $ng = ngram_counts($bertso_guztiak, $ngrama_kopurua);
my %ngramak;

for (keys %$ng) {
    $ngramak{$_} = $ng->{$_};
}

my @ngrama_ordenatuak = sort ({$ngramak{$b} <=> $ngramak{$a}} keys(%ngramak));
my @ngrama_ordenatuak_;
my %ngram_da;

my $i = 0;
foreach my $ngr (@ngrama_ordenatuak){
    $ngr =~ tr/ /_/;
    $ngrama_ordenatuak_[$i] = $ngr;
    $ngram_da{$ngr}=1;
    $i++;
}


#Behar ditugun hitz FW-ak eskuratu
my $kop = 0;
my $fw_kop = $ARGV[1];#FW kopurua


foreach my $auk (sort { $FW{$b} <=>  $FW{$a} } keys %FW){
    if (!exists($ngram_da{$auk})){
        if ($kop<$fw_kop){
            $FWaukeratuak{$auk} = 1;
        }
        $kop++;
    }
}

#ARFF sortu

open(FITXOUT1, ">$fw_kop-FW-$ngrama_kopurua-gram_test.arff") or die("Ezin da $fw_kop-FW-$ngrama_kopurua-gram_test.arff fitxategia sortu\n");
open(FITXOUT2, ">$fw_kop-FW-$ngrama_kopurua-gram_develop.arff") or die("Ezin da $fw_kop-FW-$ngrama_kopurua-gram_develop.arff fitxategia sortu\n");
open(FITXOUT3, ">$fw_kop-FW-$ngrama_kopurua-gram_train.arff") or die("Ezin da $fw_kop-FW-$ngrama_kopurua-gram_train.arff fitxategia sortu\n");


print (FITXOUT1 "\@relation $fw_kop-FW-$ngrama_kopurua-gram\n\n");
print (FITXOUT2 "\@relation $fw_kop-FW-$ngrama_kopurua-gram\n\n");
print (FITXOUT3 "\@relation $fw_kop-FW-$ngrama_kopurua-gram\n\n");


foreach my $ngr (@ngrama_ordenatuak_)
{
    print (FITXOUT1 "\@attribute $ngr real\n");
    print (FITXOUT2 "\@attribute $ngr real\n");
    print (FITXOUT3 "\@attribute $ngr real\n");
}

foreach my $hitz (@hitzak)
{
    if (exists($FWaukeratuak{$hitz})){
        print (FITXOUT1 "\@attribute $hitz real\n");
        print (FITXOUT2 "\@attribute $hitz real\n");
        print (FITXOUT3 "\@attribute $hitz real\n");
    }
}


print (FITXOUT1 "\@attribute bertsolaria {");
print (FITXOUT2 "\@attribute bertsolaria {");
print (FITXOUT3 "\@attribute bertsolaria {");

for (my $i = 1; $i <= $n; $i++)
{
    print (FITXOUT1 "$data1->{Bertsolaria}->{$i}->{Izena}");
    print (FITXOUT2 "$data2->{Bertsolaria}->{$i}->{Izena}");
    print (FITXOUT3 "$data3->{Bertsolaria}->{$i}->{Izena}");
    
    if ($i < $n){
        print (FITXOUT1 ",");
        print (FITXOUT2 ",");
        print (FITXOUT3 ",");
    }
}

print (FITXOUT1 "}\n\n");
print (FITXOUT2 "}\n\n");
print (FITXOUT3 "}\n\n");
print (FITXOUT1 "\@data\n");
print (FITXOUT2 "\@data\n");
print (FITXOUT3 "\@data\n");


for (my $i = 1; $i <= $n; $i++)
{
    my $bertsoa = "";
    
    #FW-ak eskuratu: lehenengo hitza FW den ikusi eta ez bada lema
    #Bertso bakoitzean hitz kopuruko erabilitako FW-ak kalkulatzen dira
    #N-gramak: lehenengo bertsoak eskuratu eta ondoren n-gramak. Akenik n-grama kopuruko n-grama bakoitza zenbatetan agertzen den kalkulatu
    foreach my $bertso (@{$data1->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        
        my %FW = ();
        my $kont2 = 0;
        
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                $bertsoa = $bertsoa . " " . $lerro->{w}->{content};
                if (exists($FWaukeratuak{$lerro->{w}->{content}})){
                    $FW{$lerro->{w}->{content}}++;
                }else{
                    if (exists($FWaukeratuak{$lerro->{w}->{lemma}})){
                        $FW{$lerro->{w}->{lemma}}++;
                    }
                }
                $kont2++;
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    $bertsoa = $bertsoa . " " . $hitz->{content};
                    if (exists($FWaukeratuak{$hitz->{content}})){
                        $FW{$hitz->{content}}++;
                    }else{
                        if (exists($FWaukeratuak{$hitz->{lemma}})){
                            $FW{$hitz->{lemma}}++;
                        }
                    }
                    $kont2++;
                }
            }
            $bertsoa = $bertsoa . "\n";
        }
        
        my $ng = ngram_counts($bertsoa, $ngrama_kopurua);
        my %ngram = ();
        my $kont = 0;
        
        for (keys %$ng) {
            $ngram{$_} = $ng->{$_};
            $kont++;
        }
        
        
        foreach my $ngr (@ngrama_ordenatuak){
            if (exists($ngram{$ngr})){
                $ngram{$ngr} = sprintf("%.2f", ($ngram{$ngr} / $kont) * 100);
            }else{
                $ngram{$ngr} = 0;
            }
            print (FITXOUT1 "$ngram{$ngr},");
        }
        
        foreach my $hitz (@hitzak){
            if (exists($FWaukeratuak{$hitz})){
                if (exists($FW{$hitz})){
                    $FW{$hitz} = sprintf("%.2f", ($FW{$hitz} / $kont2) * 100);
                }else{
                    $FW{$hitz} = 0;
                }
                print (FITXOUT1 "$FW{$hitz},");
            }
        }
        
        print (FITXOUT1 "$data1->{Bertsolaria}->{$i}->{Izena}\n");
        $bertsoa = "";
    }

    
    
    foreach my $bertso (@{$data2->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %FW = ();
        my $kont2 = 0;
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                $bertsoa = $bertsoa . " " . $lerro->{w}->{content};
                if (exists($FWaukeratuak{$lerro->{w}->{content}})){
                    $FW{$lerro->{w}->{content}}++;
                }else{
                    if (exists($FWaukeratuak{$lerro->{w}->{lemma}})){
                        $FW{$lerro->{w}->{lemma}}++;
                    }
                }
                $kont2++;
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    $bertsoa = $bertsoa . " " . $hitz->{content};
                    if (exists($FWaukeratuak{$hitz->{content}})){
                        $FW{$hitz->{content}}++;
                    }else{
                        if (exists($FWaukeratuak{$hitz->{lemma}})){
                            $FW{$hitz->{lemma}}++;
                        }
                    }
                    $kont2++;
                }
            }
            $bertsoa = $bertsoa . "\n";
        }
        
        
        my $ng = ngram_counts($bertsoa, $ngrama_kopurua);
        my %ngram = ();
        my $kont = 0;
        
        for (keys %$ng) {
            $ngram{$_} = $ng->{$_};
            $kont++;
        }
        
        
        foreach my $ngr (@ngrama_ordenatuak){
            if (exists($ngram{$ngr})){
                $ngram{$ngr} = sprintf("%.2f", ($ngram{$ngr} / $kont) * 100);
            }else{
                $ngram{$ngr} = 0;
            }
            print (FITXOUT2 "$ngram{$ngr},");
        }
        
        foreach my $hitz (@hitzak){
            if (exists($FWaukeratuak{$hitz})){
                if (exists($FW{$hitz})){
                    $FW{$hitz} = sprintf("%.2f", ($FW{$hitz} / $kont2) * 100);
                }else{
                    $FW{$hitz} = 0;
                }
                print (FITXOUT2 "$FW{$hitz},");
            }
        }
        print (FITXOUT2 "$data1->{Bertsolaria}->{$i}->{Izena}\n");
        $bertsoa = "";
    }
    
    foreach my $bertso (@{$data3->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %FW = ();
        my $kont2 = 0;
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                $bertsoa = $bertsoa . " " . $lerro->{w}->{content};
                if (exists($FWaukeratuak{$lerro->{w}->{content}})){
                    $FW{$lerro->{w}->{content}}++;
                }else{
                    if (exists($FWaukeratuak{$lerro->{w}->{lemma}})){
                        $FW{$lerro->{w}->{lemma}}++;
                    }
                }
                $kont2++;
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    $bertsoa = $bertsoa . " " . $hitz->{content};
                    if (exists($FWaukeratuak{$hitz->{content}})){
                        $FW{$hitz->{content}}++;
                    }else{
                        if (exists($FWaukeratuak{$hitz->{lemma}})){
                            $FW{$hitz->{lemma}}++;
                        }
                    }
                    $kont2++;
                }
            }
            $bertsoa = $bertsoa . "\n";
        }
        
        my $ng = ngram_counts($bertsoa, $ngrama_kopurua);
        my %ngram = ();
        my $kont = 0;
        
        for (keys %$ng) {
            $ngram{$_} = $ng->{$_};
            $kont++;
        }
        
        
        foreach my $ngr (@ngrama_ordenatuak){
            if (exists($ngram{$ngr})){
                $ngram{$ngr} = sprintf("%.2f", ($ngram{$ngr} / $kont) * 100);
            }else{
                $ngram{$ngr} = 0;
            }
            print (FITXOUT3 "$ngram{$ngr},");
        }
        
        foreach my $hitz (@hitzak){
            if (exists($FWaukeratuak{$hitz})){
                if (exists($FW{$hitz})){
                    $FW{$hitz} = sprintf("%.2f", ($FW{$hitz} / $kont2) * 100);
                }else{
                    $FW{$hitz} = 0;
                }
                print (FITXOUT3 "$FW{$hitz},");
            }
        }
        print (FITXOUT3 "$data1->{Bertsolaria}->{$i}->{Izena}\n");
        $bertsoa = "";
    }
}

close(FITXOUT1);
close(FITXOUT2);
close(FITXOUT3);
