#!/usr/bin/perl
use strict;
use warnings;

use XML::Simple;
use Data::Dumper;

die("Programak 2 argumentu behar ditu\n") if ($#ARGV != 1);

#Euskarazko FW-ak irakurri
open(FITXIN, "funtzio-hitzakOna.txt") or die("Ezin da funtzio-hitzakOna.txt zabaldu!\n");

my (@hitzak, $lerro, %FWda, @h);

my $j=0;

while ($lerro = <FITXIN>)
{
    chomp($lerro);
    @h = split " ", $lerro;
    if(!exists($FWda{$h[0]})){
        $FWda{$h[0]}=1;
        $hitzak[$j]=$h[0];
        $j++;
    }
}
delete($FWda{"sar"});



#FW aukeraketa

my $xml = new XML::Simple;

my $data1 = $xml->XMLin("Test.xml");
my $data2 = $xml->XMLin("Develop.xml");
my $data3 = $xml->XMLin("Train.xml");


my $n = $ARGV[0];#bertsolari kopurua
my (%FW, %FWaukeratuak);


for (my $i = 1; $i <= $n; $i++)
{
    #FW-ak eskuratu: lehenengo hitza FW den ikusi eta ez bada lema
    foreach my $bertso (@{$data1->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($FWda{$lerro->{w}->{content}}){
                    $FW{$lerro->{w}->{content}}++;
                }else{
                    if ($FWda{$lerro->{w}->{lemma}}){
                        $FW{$lerro->{w}->{lemma}}++;
                    }
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($FWda{$hitz->{content}}){
                        $FW{$hitz->{content}}++;
                    }else{
                        if ($FWda{$hitz->{lemma}}){
                            $FW{$hitz->{lemma}}++;
                        }
                    }
                }
            }
        }
    }
    foreach my $bertso (@{$data2->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($FWda{$lerro->{w}->{content}}){
                    $FW{$lerro->{w}->{content}}++;
                }else{
                    if ($FWda{$lerro->{w}->{lemma}}){
                        $FW{$lerro->{w}->{lemma}}++;
                    }
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($FWda{$hitz->{content}}){
                        $FW{$hitz->{content}}++;
                    }else{
                        if ($FWda{$hitz->{lemma}}){
                            $FW{$hitz->{lemma}}++;
                        }
                    }
                }
            }
        }
    }
    foreach my $bertso (@{$data3->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($FWda{$lerro->{w}->{content}}){
                    $FW{$lerro->{w}->{content}}++;
                }else{
                    if ($FWda{$lerro->{w}->{lemma}}){
                        $FW{$lerro->{w}->{lemma}}++;
                    }
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($FWda{$hitz->{content}}){
                        $FW{$hitz->{content}}++;
                    }else{
                        if ($FWda{$hitz->{lemma}}){
                            $FW{$hitz->{lemma}}++;
                        }
                    }
                }
            }
        }
    }
}

my $kop = 0;
my $fw_kop = $ARGV[1];#FW kopurua


foreach my $auk (sort { $FW{$b} <=>  $FW{$a} } keys %FW){
    if ($kop<$fw_kop){
        $FWaukeratuak{$auk} = 1;
    }
    $kop++;
}


#ARFF sortu

open(FITXOUT1, ">$fw_kop-fw_test.arff") or die("Ezin da $fw_kop-fw_test.arff fitxategia sortu\n");
open(FITXOUT2, ">$fw_kop-fw_develop.arff") or die("Ezin da $fw_kop-fw_develop.arff fitxategia sortu\n");
open(FITXOUT3, ">$fw_kop-fw_train.arff") or die("Ezin da $fw_kop-fw_train.arff fitxategia sortu\n");


print (FITXOUT1 "\@relation FunctionWords-$fw_kop\n\n");
print (FITXOUT2 "\@relation FunctionWords-$fw_kop\n\n");
print (FITXOUT3 "\@relation FunctionWords-$fw_kop\n\n");


foreach my $hitz (@hitzak)
{
    if (exists($FWaukeratuak{$hitz})){
        print (FITXOUT1 "\@attribute $hitz real\n");
        print (FITXOUT2 "\@attribute $hitz real\n");
        print (FITXOUT3 "\@attribute $hitz real\n");
    }
}


print (FITXOUT1 "\@attribute bertsolaria {");
print (FITXOUT2 "\@attribute bertsolaria {");
print (FITXOUT3 "\@attribute bertsolaria {");

for (my $i = 1; $i <= $n; $i++)
{
    print (FITXOUT1 "$data1->{Bertsolaria}->{$i}->{Izena}");
    print (FITXOUT2 "$data2->{Bertsolaria}->{$i}->{Izena}");
    print (FITXOUT3 "$data3->{Bertsolaria}->{$i}->{Izena}");

    if ($i < $n){
        print (FITXOUT1 ",");
        print (FITXOUT2 ",");
        print (FITXOUT3 ",");
    }
}

print (FITXOUT1 "}\n\n");
print (FITXOUT2 "}\n\n");
print (FITXOUT3 "}\n\n");
print (FITXOUT1 "\@data\n");
print (FITXOUT2 "\@data\n");
print (FITXOUT3 "\@data\n");


for (my $i = 1; $i <= $n; $i++)
{
    
    #1. FW-ak eskuratu: lehenengo hitza FW den ikusi eta ez bada lema
    #2. Bertso bakoitzean hitz kpuruko erabilitako FW-ak kalkulatzen dira
    foreach my $bertso (@{$data1->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %FW = ();
        my $kont = 0;
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if (exists($FWaukeratuak{$lerro->{w}->{content}})){
                    $FW{$lerro->{w}->{content}}++;
                }else{
                    if (exists($FWaukeratuak{$lerro->{w}->{lemma}})){
                        $FW{$lerro->{w}->{lemma}}++;
                    }
                }
                $kont++;
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if (exists($FWaukeratuak{$hitz->{content}})){
                        $FW{$hitz->{content}}++;
                    }else{
                        if (exists($FWaukeratuak{$hitz->{lemma}})){
                            $FW{$hitz->{lemma}}++;
                        }
                    }
                    $kont++;
                }
            }
        }

        
        foreach my $hitz (@hitzak){
            if (exists($FWaukeratuak{$hitz})){
                if (exists($FW{$hitz})){
                    $FW{$hitz} = sprintf("%.2f", ($FW{$hitz} / $kont) * 100);
                }else{
                    $FW{$hitz} = 0;
                }
                print (FITXOUT1 "$FW{$hitz},");
            }
        }
        print (FITXOUT1 "$data1->{Bertsolaria}->{$i}->{Izena}\n");
        
    }
    
    foreach my $bertso (@{$data2->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %FW = ();
        my $kont = 0;
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if (exists($FWaukeratuak{$lerro->{w}->{content}})){
                    $FW{$lerro->{w}->{content}}++;
                }else{
                    if (exists($FWaukeratuak{$lerro->{w}->{lemma}})){
                        $FW{$lerro->{w}->{lemma}}++;
                    }
                }
                $kont++;
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if (exists($FWaukeratuak{$hitz->{content}})){
                        $FW{$hitz->{content}}++;
                    }else{
                        if (exists($FWaukeratuak{$hitz->{lemma}})){
                            $FW{$hitz->{lemma}}++;
                        }
                    }
                    $kont++;
                }
            }
        }
        
        
        foreach my $hitz (@hitzak){
            if (exists($FWaukeratuak{$hitz})){
                if (exists($FW{$hitz})){
                    $FW{$hitz} = sprintf("%.2f", ($FW{$hitz} / $kont) * 100);
                }else{
                    $FW{$hitz} = 0;
                }
                print (FITXOUT2 "$FW{$hitz},");
            }
        }
        print (FITXOUT2 "$data2->{Bertsolaria}->{$i}->{Izena}\n");
        
    }
    
    foreach my $bertso (@{$data3->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %FW = ();
        my $kont = 0;
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if (exists($FWaukeratuak{$lerro->{w}->{content}})){
                    $FW{$lerro->{w}->{content}}++;
                }else{
                    if (exists($FWaukeratuak{$lerro->{w}->{lemma}})){
                        $FW{$lerro->{w}->{lemma}}++;
                    }
                }
                $kont++;
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if (exists($FWaukeratuak{$hitz->{content}})){
                        $FW{$hitz->{content}}++;
                    }else{
                        if (exists($FWaukeratuak{$hitz->{lemma}})){
                            $FW{$hitz->{lemma}}++;
                        }
                    }
                    $kont++;
                }
            }
        }
        
        
        foreach my $hitz (@hitzak){
            if (exists($FWaukeratuak{$hitz})){
                if (exists($FW{$hitz})){
                    $FW{$hitz} = sprintf("%.2f", ($FW{$hitz} / $kont) * 100);
                }else{
                    $FW{$hitz} = 0;
                }
                print (FITXOUT3 "$FW{$hitz},");
            }
        }
        print (FITXOUT3 "$data3->{Bertsolaria}->{$i}->{Izena}\n");
        
    }

}

close(FITXOUT1);
close(FITXOUT2);
close(FITXOUT3);
