#!/usr/bin/perl
use strict;
use warnings;

use XML::Simple;
use Data::Dumper;
use Text::Ngram qw(ngram_counts add_to_counts);



#Argumentuak: bertsolari kopurua, hitz ez-estandarren kopurua eta n-ren balioa
die("Programak 3 argumentu behar ditu\n") if ($#ARGV != 2);



my $xml = new XML::Simple;

my $data1 = $xml->XMLin("Test.xml");
my $data2 = $xml->XMLin("Develop.xml");
my $data3 = $xml->XMLin("Train.xml");


my $ngrama_kopurua = $ARGV[2];#n-ren balioa
my $n = $ARGV[0];#bertsolari kopurua
my $bertso_guztiak = "";
my (%EzEstandar, %EzEsAukeratuak);


for (my $i = 1; $i <= $n; $i++)
{
    #Hitz ez-estandarrak eskuratu: ez-estandarra bada hitza hartu
    #Bertso guztiak eskuratu
    foreach my $bertso (@{$data1->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                $bertso_guztiak = $bertso_guztiak . " " . $lerro->{w}->{content};
                if ($lerro->{w}->{ezest} eq '1'){
                    $EzEstandar{$lerro->{w}->{content}}++;
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    $bertso_guztiak = $bertso_guztiak . " " . $hitz->{content};
                    if ($hitz->{ezest} eq '1'){
                        $EzEstandar{$hitz->{content}}++;
                    }
                }
            }
            $bertso_guztiak = $bertso_guztiak . "\n";
        }
    }
    foreach my $bertso (@{$data2->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                $bertso_guztiak = $bertso_guztiak . " " . $lerro->{w}->{content};
                if ($lerro->{w}->{ezest} eq '1'){
                    $EzEstandar{$lerro->{w}->{content}}++;
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    $bertso_guztiak = $bertso_guztiak . " " . $hitz->{content};
                    if ($hitz->{ezest} eq '1'){
                        $EzEstandar{$hitz->{content}}++;
                    }
                }
            }
            $bertso_guztiak = $bertso_guztiak . "\n";
        }
    }
    foreach my $bertso (@{$data3->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{ezest} eq '1'){
                    $bertso_guztiak = $bertso_guztiak . " " . $lerro->{w}->{content};
                    $EzEstandar{$lerro->{w}->{content}}++;
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    $bertso_guztiak = $bertso_guztiak . " " . $hitz->{content};
                    if ($hitz->{ezest} eq '1'){
                        $EzEstandar{$hitz->{content}}++;
                    }
                }
            }
            $bertso_guztiak = $bertso_guztiak . "\n";
        }
    }
}

#N-gramak eskuratu
my $ng = ngram_counts($bertso_guztiak, $ngrama_kopurua);
my %ngramak;

for (keys %$ng) {
    $ngramak{$_} = $ng->{$_};
}

my @ngrama_ordenatuak = sort ({$ngramak{$b} <=> $ngramak{$a}} keys(%ngramak));
my @ngrama_ordenatuak_;
my %ngram_da;

my $i = 0;
foreach my $ngr (@ngrama_ordenatuak){
    $ngr =~ tr/ /_/;
    $ngrama_ordenatuak_[$i] = $ngr;
    $ngram_da{$ngr}=1;
    $i++;
}


#Behar ditugun hitz hitz ez-estandarrak eskuratu

my $kop = 0;
my @hitzak;
$i = 0;
my $ezeskop = $ARGV[1];#hitz ez-estandarren kopurua


foreach my $auk (sort { $EzEstandar{$b} <=>  $EzEstandar{$a} } keys %EzEstandar){
    if (!exists($ngram_da{$auk})){
        if ($auk !~ m/(\.|,|;|:|!|\?|\"|\')/){#puntuazio ikurrak kentzeko
            if ($kop<$ezeskop){
                $EzEsAukeratuak{$auk} = 1;
                $hitzak[$i]=$auk;
                $i++;
            }
            $kop++;
        }
    }
}


#ARFF sortu

open(FITXOUT1, ">$ezeskop-ezes-$ngrama_kopurua-gram_test.arff") or die("Ezin da $ezeskop-ezes-$ngrama_kopurua-gram_test.arff fitxategia sortu\n");
open(FITXOUT2, ">$ezeskop-ezes-$ngrama_kopurua-gram_develop.arff") or die("Ezin da $ezeskop-ezes-$ngrama_kopurua-gram_develop.arff fitxategia sortu\n");
open(FITXOUT3, ">$ezeskop-ezes-$ngrama_kopurua-gram_train.arff") or die("Ezin da $ezeskop-ezes-$ngrama_kopurua-gram_train.arff fitxategia sortu\n");


print (FITXOUT1 "\@relation EzEstandarrak-$ezeskop-$ngrama_kopurua-gram\n\n");
print (FITXOUT2 "\@relation EzEstandarrak-$ezeskop-$ngrama_kopurua-gram\n\n");
print (FITXOUT3 "\@relation EzEstandarrak-$ezeskop-$ngrama_kopurua-gram\n\n");


foreach my $ngr (@ngrama_ordenatuak_)
{
    print (FITXOUT1 "\@attribute $ngr real\n");
    print (FITXOUT2 "\@attribute $ngr real\n");
    print (FITXOUT3 "\@attribute $ngr real\n");
}

foreach my $hitz (@hitzak)
{
    print (FITXOUT1 "\@attribute $hitz real\n");
    print (FITXOUT2 "\@attribute $hitz real\n");
    print (FITXOUT3 "\@attribute $hitz real\n");
}


print (FITXOUT1 "\@attribute bertsolaria {");
print (FITXOUT2 "\@attribute bertsolaria {");
print (FITXOUT3 "\@attribute bertsolaria {");

for (my $i = 1; $i <= $n; $i++)
{
    print (FITXOUT1 "$data1->{Bertsolaria}->{$i}->{Izena}");
    print (FITXOUT2 "$data2->{Bertsolaria}->{$i}->{Izena}");
    print (FITXOUT3 "$data3->{Bertsolaria}->{$i}->{Izena}");

    if ($i < $n){
        print (FITXOUT1 ",");
        print (FITXOUT2 ",");
        print (FITXOUT3 ",");
    }
}

print (FITXOUT1 "}\n\n");
print (FITXOUT2 "}\n\n");
print (FITXOUT3 "}\n\n");
print (FITXOUT1 "\@data\n");
print (FITXOUT2 "\@data\n");
print (FITXOUT3 "\@data\n");


for (my $i = 1; $i <= $n; $i++)
{
    my $bertsoa = "";
    
    #Hitz ez-estandarrak eskuratu: ez-estandarra bada hitza hartu
    #Bertso bakoitzean hitz kopuruko erabilitako hitz ez-estandarrak kalkulatzen dira
    #N-gramak: lehenengo bertsoak eskuratu eta ondoren n-gramak. Akenik n-grama kopuruko n-grama bakoitza zenbatetan agertzen den kalkulatu
    foreach my $bertso (@{$data1->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %EzEs = ();
        my $kont = 0;
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                $bertsoa = $bertsoa . " " . $lerro->{w}->{content};
                if (exists($EzEsAukeratuak{$lerro->{w}->{content}}) and $lerro->{w}->{ezest} eq '1'){
                    $EzEs{$lerro->{w}->{content}}++;
                }
                $kont++;
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    $bertsoa = $bertsoa . " " . $hitz->{content};
                    if (exists($EzEsAukeratuak{$hitz->{content}}) and $hitz->{ezest} eq '1'){
                        $EzEs{$hitz->{content}}++;
                    }
                    $kont++;
                }
            }
            $bertsoa = $bertsoa . "\n";
        }
        
        my $ng = ngram_counts($bertsoa, $ngrama_kopurua);
        my %ngram = ();
        my $kont2 = 0;
        
        for (keys %$ng) {
            $ngram{$_} = $ng->{$_};
            $kont2++;
        }
        
        
        foreach my $ngr (@ngrama_ordenatuak){
            if (exists($ngram{$ngr})){
                $ngram{$ngr} = sprintf("%.2f", ($ngram{$ngr} / $kont2) * 100);
            }else{
                $ngram{$ngr} = 0;
            }
            print (FITXOUT1 "$ngram{$ngr},");
        }

        
        foreach my $hitz (@hitzak){
            if (exists($EzEs{$hitz})){
                $EzEs{$hitz} = sprintf("%.2f", ($EzEs{$hitz} / $kont) * 100);
            }else{
                $EzEs{$hitz} = 0;
            }
            print (FITXOUT1 "$EzEs{$hitz},");
        }
        print (FITXOUT1 "$data1->{Bertsolaria}->{$i}->{Izena}\n");
        my $bertsoa = "";
        
    }
    
    foreach my $bertso (@{$data2->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %EzEs = ();
        my $kont = 0;
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                $bertsoa = $bertsoa . " " . $lerro->{w}->{content};
                if (exists($EzEsAukeratuak{$lerro->{w}->{content}}) and $lerro->{w}->{ezest} eq '1'){
                    $EzEs{$lerro->{w}->{content}}++;
                }
                $kont++;
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    $bertsoa = $bertsoa . " " . $hitz->{content};
                    if (exists($EzEsAukeratuak{$hitz->{content}}) and $hitz->{ezest} eq '1'){
                        $EzEs{$hitz->{content}}++;
                    }
                    $kont++;
                }
            }
            $bertsoa = $bertsoa . "\n";
        }
        
        my $ng = ngram_counts($bertsoa, $ngrama_kopurua);
        my %ngram = ();
        my $kont2 = 0;
        
        for (keys %$ng) {
            $ngram{$_} = $ng->{$_};
            $kont2++;
        }
        
        
        foreach my $ngr (@ngrama_ordenatuak){
            if (exists($ngram{$ngr})){
                $ngram{$ngr} = sprintf("%.2f", ($ngram{$ngr} / $kont2) * 100);
            }else{
                $ngram{$ngr} = 0;
            }
            print (FITXOUT2 "$ngram{$ngr},");
        }
        
        
        foreach my $hitz (@hitzak){
            if (exists($EzEs{$hitz})){
                $EzEs{$hitz} = sprintf("%.2f", ($EzEs{$hitz} / $kont) * 100);
            }else{
                $EzEs{$hitz} = 0;
            }
            print (FITXOUT2 "$EzEs{$hitz},");
        }
        print (FITXOUT2 "$data2->{Bertsolaria}->{$i}->{Izena}\n");
        my $bertsoa = "";
        
    }
        

    
    foreach my $bertso (@{$data3->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %EzEs = ();
        my $kont = 0;
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                $bertsoa = $bertsoa . " " . $lerro->{w}->{content};
                if (exists($EzEsAukeratuak{$lerro->{w}->{content}}) and $lerro->{w}->{ezest} eq '1'){
                    $EzEs{$lerro->{w}->{content}}++;
                }
                $kont++;
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    $bertsoa = $bertsoa . " " . $hitz->{content};
                    if (exists($EzEsAukeratuak{$hitz->{content}}) and $hitz->{ezest} eq '1'){
                        $EzEs{$hitz->{content}}++;
                    }
                    $kont++;
                }
            }
            $bertsoa = $bertsoa . "\n";
        }
        
        my $ng = ngram_counts($bertsoa, $ngrama_kopurua);
        my %ngram = ();
        my $kont2 = 0;
        
        for (keys %$ng) {
            $ngram{$_} = $ng->{$_};
            $kont2++;
        }
        
        
        foreach my $ngr (@ngrama_ordenatuak){
            if (exists($ngram{$ngr})){
                $ngram{$ngr} = sprintf("%.2f", ($ngram{$ngr} / $kont2) * 100);
            }else{
                $ngram{$ngr} = 0;
            }
            print (FITXOUT3 "$ngram{$ngr},");
        }
        
        
        foreach my $hitz (@hitzak){
            if (exists($EzEs{$hitz})){
                $EzEs{$hitz} = sprintf("%.2f", ($EzEs{$hitz} / $kont) * 100);
            }else{
                $EzEs{$hitz} = 0;
            }
            print (FITXOUT3 "$EzEs{$hitz},");
        }
        print (FITXOUT3 "$data3->{Bertsolaria}->{$i}->{Izena}\n");
        my $bertsoa = "";
        
    }
}

close(FITXOUT1);
close(FITXOUT2);
close(FITXOUT3);
