#!/usr/bin/perl
use strict;
use warnings;

use XML::Simple;
use Data::Dumper;

die("Programak 2 argumentu behar ditu\n") if ($#ARGV != 1);



my $xml = new XML::Simple;

my $data1 = $xml->XMLin("Test.xml");
my $data2 = $xml->XMLin("Develop.xml");
my $data3 = $xml->XMLin("Train.xml");


my $n = $ARGV[0];#bertsolari kopurua
my (%EzEstandar, %EzEsAukeratuak);


for (my $i = 1; $i <= $n; $i++)
{
    #Hitz ez-estandarrak eskuratu: ez-estandarra bada hitza hartu
    foreach my $bertso (@{$data1->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{ezest} eq '1'){
                    $EzEstandar{$lerro->{w}->{content}}++;
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($hitz->{ezest} eq '1'){
                        $EzEstandar{$hitz->{content}}++;
                    }
                }
            }
        }
    }
    foreach my $bertso (@{$data2->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{ezest} eq '1'){
                    $EzEstandar{$lerro->{w}->{content}}++;
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($hitz->{ezest} eq '1'){
                        $EzEstandar{$hitz->{content}}++;
                    }
                }
            }
        }
    }
    foreach my $bertso (@{$data3->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{ezest} eq '1'){
                    $EzEstandar{$lerro->{w}->{content}}++;
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($hitz->{ezest} eq '1'){
                        $EzEstandar{$hitz->{content}}++;
                    }
                }
            }
        }
    }
}

my $kop = 0;
my @hitzak;
my $i = 0;
my $ezeskop = $ARGV[1];#hitz ez-estandarren kopurua



foreach my $auk (sort { $EzEstandar{$b} <=>  $EzEstandar{$a} } keys %EzEstandar){
    if ($auk !~ m/(\.|,|;|:|!|\?|\"|\')/){#puntuazio ikurrak kentzeko
        if ($kop<$ezeskop){
            $EzEsAukeratuak{$auk} = 1;
            $hitzak[$i]=$auk;
            $i++;
        }
        $kop++;
    }
}


#ARFF sortu

open(FITXOUT1, ">$ezeskop-ezes_test.arff") or die("Ezin da $ezeskop-ezes_test.arff fitxategia sortu\n");
open(FITXOUT2, ">$ezeskop-ezes_develop.arff") or die("Ezin da $ezeskop-ezes_develop.arff fitxategia sortu\n");
open(FITXOUT3, ">$ezeskop-ezes_train.arff") or die("Ezin da $ezeskop-ezes_train.arff fitxategia sortu\n");


print (FITXOUT1 "\@relation EzEstandarrak-$ezeskop\n\n");
print (FITXOUT2 "\@relation EzEstandarrak-$ezeskop\n\n");
print (FITXOUT3 "\@relation EzEstandarrak-$ezeskop\n\n");


foreach my $hitz (@hitzak)
{
    print (FITXOUT1 "\@attribute $hitz real\n");
    print (FITXOUT2 "\@attribute $hitz real\n");
    print (FITXOUT3 "\@attribute $hitz real\n");
}


print (FITXOUT1 "\@attribute bertsolaria {");
print (FITXOUT2 "\@attribute bertsolaria {");
print (FITXOUT3 "\@attribute bertsolaria {");

for (my $i = 1; $i <= $n; $i++)
{
    print (FITXOUT1 "$data1->{Bertsolaria}->{$i}->{Izena}");
    print (FITXOUT2 "$data2->{Bertsolaria}->{$i}->{Izena}");
    print (FITXOUT3 "$data3->{Bertsolaria}->{$i}->{Izena}");

    if ($i < $n){
        print (FITXOUT1 ",");
        print (FITXOUT2 ",");
        print (FITXOUT3 ",");
    }
}

print (FITXOUT1 "}\n\n");
print (FITXOUT2 "}\n\n");
print (FITXOUT3 "}\n\n");
print (FITXOUT1 "\@data\n");
print (FITXOUT2 "\@data\n");
print (FITXOUT3 "\@data\n");


for (my $i = 1; $i <= $n; $i++)
{
    
    #1. Hitz ez-estandarrak eskuratu: ez-estandarra bada hitza hartu
    #2. Bertso bakoitzean hitz kopuruko erabilitako hitz ez-estandarrak kalkulatzen dira
    foreach my $bertso (@{$data1->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %EzEs = ();
        my $kont = 0;
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if (exists($EzEsAukeratuak{$lerro->{w}->{content}}) and $lerro->{w}->{ezest} eq '1'){
                    $EzEs{$lerro->{w}->{content}}++;
                }
                $kont++;
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if (exists($EzEsAukeratuak{$hitz->{content}}) and $hitz->{ezest} eq '1'){
                        $EzEs{$hitz->{content}}++;
                    }
                    $kont++;
                }
            }
        }

        
        foreach my $hitz (@hitzak){
            if (exists($EzEs{$hitz})){
                $EzEs{$hitz} = sprintf("%.2f", ($EzEs{$hitz} / $kont) * 100);
            }else{
                $EzEs{$hitz} = 0;
            }
            print (FITXOUT1 "$EzEs{$hitz},");
        }
        print (FITXOUT1 "$data1->{Bertsolaria}->{$i}->{Izena}\n");
        
    }
    
    foreach my $bertso (@{$data2->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %EzEs = ();
        my $kont = 0;
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if (exists($EzEsAukeratuak{$lerro->{w}->{content}}) and $lerro->{w}->{ezest} eq '1'){
                    $EzEs{$lerro->{w}->{content}}++;
                }
                $kont++;
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if (exists($EzEsAukeratuak{$hitz->{content}}) and $hitz->{ezest} eq '1'){
                        $EzEs{$hitz->{content}}++;
                    }
                    $kont++;
                }
            }
        }
        
        
        foreach my $hitz (@hitzak){
            if (exists($EzEs{$hitz})){
                $EzEs{$hitz} = sprintf("%.2f", ($EzEs{$hitz} / $kont) * 100);
            }else{
                $EzEs{$hitz} = 0;
            }
            print (FITXOUT2 "$EzEs{$hitz},");
        }
        print (FITXOUT2 "$data2->{Bertsolaria}->{$i}->{Izena}\n");
        
    }
        

    
    foreach my $bertso (@{$data3->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %EzEs = ();
        my $kont = 0;
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if (exists($EzEsAukeratuak{$lerro->{w}->{content}}) and $lerro->{w}->{ezest} eq '1'){
                    $EzEs{$lerro->{w}->{content}}++;
                }
                $kont++;
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if (exists($EzEsAukeratuak{$hitz->{content}}) and $hitz->{ezest} eq '1'){
                        $EzEs{$hitz->{content}}++;
                    }
                    $kont++;
                }
            }
        }
        
        
        foreach my $hitz (@hitzak){
            if (exists($EzEs{$hitz})){
                $EzEs{$hitz} = sprintf("%.2f", ($EzEs{$hitz} / $kont) * 100);
            }else{
                $EzEs{$hitz} = 0;
            }
            print (FITXOUT3 "$EzEs{$hitz},");
        }
        print (FITXOUT3 "$data3->{Bertsolaria}->{$i}->{Izena}\n");
        
    }
}

close(FITXOUT1);
close(FITXOUT2);
close(FITXOUT3);
