#!/usr/bin/perl
use strict;
use warnings;

use XML::Simple;
use Data::Dumper;
use Text::Ngrams;

my $xml = new XML::Simple;

die("Programak 2 argumentu behar ditu\n") if ($#ARGV != 1);

my $data1 = $xml->XMLin("Test.xml");
my $data2 = $xml->XMLin("Develop.xml");
my $data3 = $xml->XMLin("Train.xml");

my $ngrama_kopurua = $ARGV[1];#n-ren balioa
my $n = $ARGV[0];#bertsolari kopurua
my $bertso_guztiak = "";


#Bertso guztiak eskuratu
for (my $i = 1; $i <= $n; $i++)
{
    my $j = 0;
    
    foreach my $bertso (@{$data1->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                $bertso_guztiak = $bertso_guztiak . " " . $lerro->{w}->{content};
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    $bertso_guztiak = $bertso_guztiak . " " . $hitz->{content};
                }
            }
            $bertso_guztiak = $bertso_guztiak . "\n";
        }
    }
    foreach my $bertso (@{$data2->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                $bertso_guztiak = $bertso_guztiak . " " . $lerro->{w}->{content};
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    $bertso_guztiak = $bertso_guztiak . " " . $hitz->{content};
                }
            }
            $bertso_guztiak = $bertso_guztiak . "\n";
        }
    }
    foreach my $bertso (@{$data3->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                $bertso_guztiak = $bertso_guztiak . " " . $lerro->{w}->{content};
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    $bertso_guztiak = $bertso_guztiak . " " . $hitz->{content};
                }
            }
            $bertso_guztiak = $bertso_guztiak . "\n";
        }
    }
}

$bertso_guztiak =~ tr/A-Z/a-z/;#hitz larriak xehera pasa

#N-gramak eskuratu
my $ng = Text::Ngrams->new(type => 'word', windowsize => $ngrama_kopurua);
$ng->process_text($bertso_guztiak);
my @ngram_ordenatuak = $ng->get_ngrams(ordeby => 'frecuency');
my (@ngramak, @ngramak_);


my %ngramak;
my $i = 0;
my $j = 0;
for my $ngr (@ngram_ordenatuak){
    if ($i % 2 == 0){
        $ngramak{$ngram_ordenatuak[$i]} = $ngram_ordenatuak[$i+1];
        $ngramak[$j] = $ngram_ordenatuak[$i];
        $ngr =~ tr/ /_/;
        $ngramak_[$j] = $ngr;
        $j++;
    }
    $i++;
}



#ARFF sortu

open(FITXOUT1, ">$ngrama_kopurua-gram_hitz_test.arff") or die("Ezin da $ngrama_kopurua-gram_hitz_test.arff fitxategia sortu\n");
open(FITXOUT2, ">$ngrama_kopurua-gram_hitz_develop.arff") or die("Ezin da $ngrama_kopurua-gram_hitz_develop.arff fitxategia sortu\n");
open(FITXOUT3, ">$ngrama_kopurua-gram_hitz_train.arff") or die("Ezin da $ngrama_kopurua-gram_hitz_train.arff fitxategia sortu\n");


print (FITXOUT1 "\@relation $ngrama_kopurua-gram_hitz\n\n");
print (FITXOUT2 "\@relation $ngrama_kopurua-gram_hitz\n\n");
print (FITXOUT3 "\@relation $ngrama_kopurua-gram_hitz\n\n");


foreach my $ngr (@ngramak_)
{
    print (FITXOUT1 "\@attribute $ngr real\n");
    print (FITXOUT2 "\@attribute $ngr real\n");
    print (FITXOUT3 "\@attribute $ngr real\n");
}


print (FITXOUT1 "\@attribute bertsolaria {");
print (FITXOUT2 "\@attribute bertsolaria {");
print (FITXOUT3 "\@attribute bertsolaria {");

for (my $i = 1; $i <= $n; $i++)
{
    print (FITXOUT1 "$data1->{Bertsolaria}->{$i}->{Izena}");
    print (FITXOUT2 "$data2->{Bertsolaria}->{$i}->{Izena}");
    print (FITXOUT3 "$data3->{Bertsolaria}->{$i}->{Izena}");
    
    if ($i < $n){
        print (FITXOUT1 ",");
        print (FITXOUT2 ",");
        print (FITXOUT3 ",");
    }
}

print (FITXOUT1 "}\n\n");
print (FITXOUT2 "}\n\n");
print (FITXOUT3 "}\n\n");
print (FITXOUT1 "\@data\n");
print (FITXOUT2 "\@data\n");
print (FITXOUT3 "\@data\n");


for (my $i = 1; $i <= $n; $i++)
{
    my $bertsoa = "";
    
    #Lehenengo bertsoak eskuratu eta ondoren n-gramak. Akenik n-grama kopuruko n-grama bakoitza zenbatetan agertzen den kalkulatu
    foreach my $bertso (@{$data1->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                $bertsoa = $bertsoa . " " . $lerro->{w}->{content};
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    $bertsoa = $bertsoa . " " . $hitz->{content};
                }
            }
            $bertsoa = $bertsoa . "\n";
        }
        
        $bertsoa =~ tr/A-Z/a-z/;
        
        my $ng = Text::Ngrams->new(type => 'word', windowsize => $ngrama_kopurua);
        $ng->process_text($bertsoa);
        my @_ngram = $ng->get_ngrams(ordeby => 'frecuency');
        
        my %ngram = ();
        my $k = 0;
        my $kont = 0;
        for my $ngr (@_ngram){
            if ($k % 2 == 0){
                $ngram{$_ngram[$k]} = $_ngram[$k+1];
                $kont++;
            }
            $k++;
        }
        
        
        foreach my $ngr (@ngramak){
            if (exists($ngram{$ngr})){
                $ngram{$ngr} = sprintf("%.2f", ($ngram{$ngr} / $kont) * 100);
            }else{
                $ngram{$ngr} = 0;
            }
            print (FITXOUT1 "$ngram{$ngr},");
        }
        print (FITXOUT1 "$data1->{Bertsolaria}->{$i}->{Izena}\n");
        $bertsoa = "";
    }

    
    
    foreach my $bertso (@{$data2->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                $bertsoa = $bertsoa . " " . $lerro->{w}->{content};
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    $bertsoa = $bertsoa . " " . $hitz->{content};
                }
            }
            $bertsoa = $bertsoa . "\n";
        }
        
        
        $bertsoa =~ tr/A-Z/a-z/;
        
        my $ng = Text::Ngrams->new(type => 'word', windowsize => $ngrama_kopurua);
        $ng->process_text($bertsoa);
        my @_ngram = $ng->get_ngrams(ordeby => 'frecuency');
        
        my %ngram = ();
        my $k = 0;
        my $kont = 0;
        for my $ngr (@_ngram){
            if ($k % 2 == 0){
                $ngram{$_ngram[$k]} = $_ngram[$k+1];
                $kont++;
            }
            $k++;
        }
        
        
        foreach my $ngr (@ngramak){
            if (exists($ngram{$ngr})){
                $ngram{$ngr} = sprintf("%.2f", ($ngram{$ngr} / $kont) * 100);
            }else{
                $ngram{$ngr} = 0;
            }
            print (FITXOUT2 "$ngram{$ngr},");
        }
        print (FITXOUT2 "$data1->{Bertsolaria}->{$i}->{Izena}\n");
        $bertsoa = "";
    }
    
    foreach my $bertso (@{$data3->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                $bertsoa = $bertsoa . " " . $lerro->{w}->{content};
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    $bertsoa = $bertsoa . " " . $hitz->{content};
                }
            }
            $bertsoa = $bertsoa . "\n";
        }
        
        $bertsoa =~ tr/A-Z/a-z/;
        
        my $ng = Text::Ngrams->new(type => 'word', windowsize => $ngrama_kopurua);
        $ng->process_text($bertsoa);
        my @_ngram = $ng->get_ngrams(ordeby => 'frecuency');
        
        my %ngram = ();
        my $k = 0;
        my $kont = 0;
        for my $ngr (@_ngram){
            if ($k % 2 == 0){
                $ngram{$_ngram[$k]} = $_ngram[$k+1];
                $kont++;
            }
            $k++;
        }
        
        
        foreach my $ngr (@ngramak){
            if (exists($ngram{$ngr})){
                $ngram{$ngr} = sprintf("%.2f", ($ngram{$ngr} / $kont) * 100);
            }else{
                $ngram{$ngr} = 0;
            }
            print (FITXOUT3 "$ngram{$ngr},");
        }
        print (FITXOUT3 "$data1->{Bertsolaria}->{$i}->{Izena}\n");
        $bertsoa = "";
    }
}

close(FITXOUT1);
close(FITXOUT2);
close(FITXOUT3);
