#!/usr/bin/perl
use strict;
use warnings;

use XML::Simple;
use Data::Dumper;
use Text::Ngram qw(ngram_counts add_to_counts);

my $xml = new XML::Simple;

die("Programak 2 argumentu behar ditu\n") if ($#ARGV != 1);

my $data1 = $xml->XMLin("Test.xml");
my $data2 = $xml->XMLin("Develop.xml");
my $data3 = $xml->XMLin("Train.xml");

my $ngrama_kopurua = $ARGV[1];#n-ren balioa
my $n = $ARGV[0];#bertsolari kopurua
my $bertso_guztiak = "";

#Bertso guztiak eskuratu
for (my $i = 1; $i <= $n; $i++)
{
    my $j = 0;
    
    foreach my $bertso (@{$data1->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                $bertso_guztiak = $bertso_guztiak . " " . $lerro->{w}->{content};
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    $bertso_guztiak = $bertso_guztiak . " " . $hitz->{content};
                }
            }
            $bertso_guztiak = $bertso_guztiak . "\n";
        }
    }
    foreach my $bertso (@{$data2->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                $bertso_guztiak = $bertso_guztiak . " " . $lerro->{w}->{content};
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    $bertso_guztiak = $bertso_guztiak . " " . $hitz->{content};
                }
            }
            $bertso_guztiak = $bertso_guztiak . "\n";
        }
    }
    foreach my $bertso (@{$data3->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                $bertso_guztiak = $bertso_guztiak . " " . $lerro->{w}->{content};
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    $bertso_guztiak = $bertso_guztiak . " " . $hitz->{content};
                }
            }
            $bertso_guztiak = $bertso_guztiak . "\n";
        }
    }
}

#N-gramak eskuratu
my $ng = ngram_counts($bertso_guztiak, $ngrama_kopurua);
my %ngramak;

for (keys %$ng) {
    $ngramak{$_} = $ng->{$_};
}

my @ngrama_ordenatuak = sort ({$ngramak{$b} <=> $ngramak{$a}} keys(%ngramak));
my @ngrama_ordenatuak_;

my $i = 0;
foreach my $ngr (@ngrama_ordenatuak){
    $ngr =~ tr/ /_/;
    $ngrama_ordenatuak_[$i] = $ngr;
    $i++;
}

#ARFF sortu

open(FITXOUT1, ">$ngrama_kopurua-gram_test.arff") or die("Ezin da $ngrama_kopurua-gram_test.arff fitxategia sortu\n");
open(FITXOUT2, ">$ngrama_kopurua-gram_develop.arff") or die("Ezin da $ngrama_kopurua-gram_develop.arff fitxategia sortu\n");
open(FITXOUT3, ">$ngrama_kopurua-gram_train.arff") or die("Ezin da $ngrama_kopurua-gram_train.arff fitxategia sortu\n");


print (FITXOUT1 "\@relation $ngrama_kopurua-gram\n\n");
print (FITXOUT2 "\@relation $ngrama_kopurua-gram\n\n");
print (FITXOUT3 "\@relation $ngrama_kopurua-gram\n\n");


foreach my $ngr (@ngrama_ordenatuak_)
{
    print (FITXOUT1 "\@attribute $ngr real\n");
    print (FITXOUT2 "\@attribute $ngr real\n");
    print (FITXOUT3 "\@attribute $ngr real\n");
}


print (FITXOUT1 "\@attribute bertsolaria {");
print (FITXOUT2 "\@attribute bertsolaria {");
print (FITXOUT3 "\@attribute bertsolaria {");

for (my $i = 1; $i <= $n; $i++)
{
    print (FITXOUT1 "$data1->{Bertsolaria}->{$i}->{Izena}");
    print (FITXOUT2 "$data2->{Bertsolaria}->{$i}->{Izena}");
    print (FITXOUT3 "$data3->{Bertsolaria}->{$i}->{Izena}");
    
    if ($i < $n){
        print (FITXOUT1 ",");
        print (FITXOUT2 ",");
        print (FITXOUT3 ",");
    }
}

print (FITXOUT1 "}\n\n");
print (FITXOUT2 "}\n\n");
print (FITXOUT3 "}\n\n");
print (FITXOUT1 "\@data\n");
print (FITXOUT2 "\@data\n");
print (FITXOUT3 "\@data\n");


for (my $i = 1; $i <= $n; $i++)
{
    my $bertsoa = "";
    
    #Lehenengo bertsoak eskuratu eta ondoren n-gramak. Akenik n-grama kopuruko n-grama bakoitza zenbatetan agertzen den kalkulatu
    foreach my $bertso (@{$data1->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                $bertsoa = $bertsoa . " " . $lerro->{w}->{content};
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    $bertsoa = $bertsoa . " " . $hitz->{content};
                }
            }
            $bertsoa = $bertsoa . "\n";
        }
        
        my $ng = ngram_counts($bertsoa, $ngrama_kopurua);
        my %ngram = ();
        my $kont = 0;
        
        for (keys %$ng) {
            $ngram{$_} = $ng->{$_};
            $kont++;
        }
        
        
        foreach my $ngr (@ngrama_ordenatuak){
            if (exists($ngram{$ngr})){
                $ngram{$ngr} = sprintf("%.2f", ($ngram{$ngr} / $kont) * 100);
            }else{
                $ngram{$ngr} = 0;
            }
            print (FITXOUT1 "$ngram{$ngr},");
        }
        print (FITXOUT1 "$data1->{Bertsolaria}->{$i}->{Izena}\n");
        $bertsoa = "";
    }

    
    
    foreach my $bertso (@{$data2->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                $bertsoa = $bertsoa . " " . $lerro->{w}->{content};
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    $bertsoa = $bertsoa . " " . $hitz->{content};
                }
            }
            $bertsoa = $bertsoa . "\n";
        }
        
        
        my $ng = ngram_counts($bertsoa, $ngrama_kopurua);
        my %ngram = ();
        my $kont = 0;
        
        for (keys %$ng) {
            $ngram{$_} = $ng->{$_};
            $kont++;
        }
        
        
        foreach my $ngr (@ngrama_ordenatuak){
            if (exists($ngram{$ngr})){
                $ngram{$ngr} = sprintf("%.2f", ($ngram{$ngr} / $kont) * 100);
            }else{
                $ngram{$ngr} = 0;
            }
            print (FITXOUT2 "$ngram{$ngr},");
        }
        print (FITXOUT2 "$data1->{Bertsolaria}->{$i}->{Izena}\n");
        $bertsoa = "";
    }
    
    foreach my $bertso (@{$data3->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                $bertsoa = $bertsoa . " " . $lerro->{w}->{content};
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    $bertsoa = $bertsoa . " " . $hitz->{content};
                }
            }
            $bertsoa = $bertsoa . "\n";
        }
        
        my $ng = ngram_counts($bertsoa, $ngrama_kopurua);
        my %ngram = ();
        my $kont = 0;
        
        for (keys %$ng) {
            $ngram{$_} = $ng->{$_};
            $kont++;
        }
        
        
        foreach my $ngr (@ngrama_ordenatuak){
            if (exists($ngram{$ngr})){
                $ngram{$ngr} = sprintf("%.2f", ($ngram{$ngr} / $kont) * 100);
            }else{
                $ngram{$ngr} = 0;
            }
            print (FITXOUT3 "$ngram{$ngr},");
        }
        print (FITXOUT3 "$data1->{Bertsolaria}->{$i}->{Izena}\n");
        $bertsoa = "";
    }
}

close(FITXOUT1);
close(FITXOUT2);
close(FITXOUT3);
