#!/usr/bin/perl
use strict;
use warnings;
use FileHandle;
use IPC::Open2;
use locale;


use XML::Simple;
use Data::Dumper;

die("Programak argumentu bat behar du\n") if ($#ARGV != 0);


my $xml = new XML::Simple;

my $data1 = $xml->XMLin("Test.xml");
my $data2 = $xml->XMLin("Develop.xml");
my $data3 = $xml->XMLin("Train.xml");


my $n = $ARGV[0];#bertsolari kopurua
my ($oina, $errima, $hitza, %OinaDa, %OinAukeratuak);
my $pidFOMA = open2(*Reader, *Writer, "flookup -i -x -b errimaPatroia.fst");#errimak lortzeko automata


#Lehenengo bertso bakoitzeko errima eskuratu, eta hori jakinda oinak
for (my $i = 1; $i <= $n; $i++)
{
    foreach my $bertso (@{$data1->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %errimak_bertsoko = ();
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{content} =~ m/\w/){
                    $hitza = $lerro->{w}->{content};
                    $hitza =~ s/[\.,;:!\?\"\']//;
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($hitz->{content} =~ m/\w/){
                        $hitza = $hitz->{content};
                        $hitza =~ s/[\.,;:!\?\"\']//;
                    }
                }
            }
            $oina = $hitza;
            $errimak_bertsoko{errima_atera($oina)}++;
        }
        
        #gehien errepikatzen dena da bertsoko errima
        my @err = sort{$errimak_bertsoko{$b} <=> $errimak_bertsoko{$a}} keys(%errimak_bertsoko);
        $errima = $err[0];
        
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{content} =~ m/\w/){
                    $hitza = $lerro->{w}->{content};
                    $hitza =~ s/[\.,;:!\?\"\']//;
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($hitz->{content} =~ m/\w/){
                        $hitza = $hitz->{content};
                        $hitza =~ s/[\.,;:!\?\"\']//;
                    }
                }
            }
            $oina = $hitza;
            if (errima_atera($oina) eq $errima){
                $OinaDa{$oina}=1;
            }
        }
    }
    
    
    
    foreach my $bertso (@{$data2->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %errimak_bertsoko = ();
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{content} =~ m/\w/){
                    $hitza = $lerro->{w}->{content};
                    $hitza =~ s/[\.,;:!\?\"\']//;
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($hitz->{content} =~ m/\w/){
                        $hitza = $hitz->{content};
                        $hitza =~ s/[\.,;:!\?\"\']//;
                    }
                }
            }
            $oina = $hitza;
            $errimak_bertsoko{errima_atera($oina)}++;
        }
        
        #gehien errepikatzen dena da bertsoko errima
        my @err = sort{$errimak_bertsoko{$b} <=> $errimak_bertsoko{$a}} keys(%errimak_bertsoko);
        $errima = $err[0];
        
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{content} =~ m/\w/){
                    $hitza = $lerro->{w}->{content};
                    $hitza =~ s/[\.,;:!\?\"\']//;
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($hitz->{content} =~ m/\w/){
                        $hitza = $hitz->{content};
                        $hitza =~ s/[\.,;:!\?\"\']//;
                    }
                }
            }
            $oina = $hitza;
            if (errima_atera($oina) eq $errima){
                $OinaDa{$oina}=1;
            }
        }
    }
    
    foreach my $bertso (@{$data3->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %errimak_bertsoko = ();
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{content} =~ m/\w/){
                    $hitza = $lerro->{w}->{content};
                    $hitza =~ s/[\.,;:!\?\"\']//;
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($hitz->{content} =~ m/\w/){
                        $hitza = $hitz->{content};
                        $hitza =~ s/[\.,;:!\?\"\']//;
                    }
                }
            }
            $oina = $hitza;
            $errimak_bertsoko{errima_atera($oina)}++;
        }
        
        #gehien errepikatzen dena da bertsoko errima
        my @err = sort{$errimak_bertsoko{$b} <=> $errimak_bertsoko{$a}} keys(%errimak_bertsoko);
        $errima = $err[0];
        
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{content} =~ m/\w/){
                    $hitza = $lerro->{w}->{content};
                    $hitza =~ s/[\.,;:!\?\"\']//;
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($hitz->{content} =~ m/\w/){
                        $hitza = $hitz->{content};
                        $hitza =~ s/[\.,;:!\?\"\']//;
                    }
                }
            }
            $oina = $hitza;
            if (errima_atera($oina) eq $errima){
                $OinaDa{$oina}=1;
            }
        }
    }
}


my @hitzak = sort{$OinaDa{$b} <=> $OinaDa{$a}} keys(%OinaDa);




#ARFF sortu

open(FITXOUT1, ">oinak_test.arff") or die("Ezin da oinak_test.arff fitxategia sortu\n");
open(FITXOUT2, ">oinak_develop.arff") or die("Ezin da oinak_develop.arff fitxategia sortu\n");
open(FITXOUT3, ">oinak_train.arff") or die("Ezin da oinak_train.arff fitxategia sortu\n");


print (FITXOUT1 "\@relation Oinak\n\n");
print (FITXOUT2 "\@relation Oinak\n\n");
print (FITXOUT3 "\@relation Oinak\n\n");


foreach my $o (@hitzak)
{
    print (FITXOUT1 "\@attribute $o real\n");
    print (FITXOUT2 "\@attribute $o real\n");
    print (FITXOUT3 "\@attribute $o real\n");
}


print (FITXOUT1 "\@attribute bertsolaria {");
print (FITXOUT2 "\@attribute bertsolaria {");
print (FITXOUT3 "\@attribute bertsolaria {");


for (my $i = 1; $i <= $n; $i++)
{
    print (FITXOUT1 "$data1->{Bertsolaria}->{$i}->{Izena}");
    print (FITXOUT2 "$data2->{Bertsolaria}->{$i}->{Izena}");
    print (FITXOUT3 "$data3->{Bertsolaria}->{$i}->{Izena}");
    
    if ($i < $n){
        print (FITXOUT1 ",");
        print (FITXOUT2 ",");
        print (FITXOUT3 ",");
    }
}

print (FITXOUT1 "}\n\n");
print (FITXOUT2 "}\n\n");
print (FITXOUT3 "}\n\n");
print (FITXOUT1 "\@data\n");
print (FITXOUT2 "\@data\n");
print (FITXOUT3 "\@data\n");


for (my $i = 1; $i <= $n; $i++)
{
    
    #Lehenengo bertso bakoitzeko errima eskuratu, eta hori jakinda oinak
    foreach my $bertso (@{$data1->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %errimak_bertsoko = ();
        my ($errima, $hitza, $oina);
        my %Oinak = ();
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{content} =~ m/\w/){
                    $hitza = $lerro->{w}->{content};
                    $hitza =~ s/[\.,;:!\?\"\']//;
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($hitz->{content} =~ m/\w/){
                        $hitza = $hitz->{content};
                        $hitza =~ s/[\.,;:!\?\"\']//;
                    }
                }
            }
            $oina = $hitza;
            $errimak_bertsoko{errima_atera($oina)}++;
        }
        
        #gehien errepikatzen dena da bertsoko errima
        my @err = sort{$errimak_bertsoko{$b} <=> $errimak_bertsoko{$a}} keys(%errimak_bertsoko);
        $errima = $err[0];
        
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{content} =~ m/\w/){
                    $hitza = $lerro->{w}->{content};
                    $hitza =~ s/[\.,;:!\?\"\']//;
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($hitz->{content} =~ m/\w/){
                        $hitza = $hitz->{content};
                        $hitza =~ s/[\.,;:!\?\"\']//;
                    }
                }
            }
            $oina = $hitza;
            if (errima_atera($oina) eq $errima){
                $Oinak{$oina}++;
            }
        }
        
        
        foreach my $o (@hitzak){
            if (exists($Oinak{$o})){
                print (FITXOUT1 "$Oinak{$o},");
            }else{
                print (FITXOUT1 "0,");
            }
        }

        print (FITXOUT1 "$data1->{Bertsolaria}->{$i}->{Izena}\n");
        
    }
    
    foreach my $bertso (@{$data2->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %errimak_bertsoko = ();
        my ($errima, $hitza, $oina);
        my %Oinak = ();
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{content} =~ m/\w/){
                    $hitza = $lerro->{w}->{content};
                    $hitza =~ s/[\.,;:!\?\"\']//;
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($hitz->{content} =~ m/\w/){
                        $hitza = $hitz->{content};
                        $hitza =~ s/[\.,;:!\?\"\']//;
                    }
                }
            }
            $oina = $hitza;
            $errimak_bertsoko{errima_atera($oina)}++;
        }
        
        #gehien errepikatzen dena da bertsoko errima
        my @err = sort{$errimak_bertsoko{$b} <=> $errimak_bertsoko{$a}} keys(%errimak_bertsoko);
        $errima = $err[0];
        
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{content} =~ m/\w/){
                    $hitza = $lerro->{w}->{content};
                    $hitza =~ s/[\.,;:!\?\"\']//;
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($hitz->{content} =~ m/\w/){
                        $hitza = $hitz->{content};
                        $hitza =~ s/[\.,;:!\?\"\']//;
                    }
                }
            }
            $oina = $hitza;
            if (errima_atera($oina) eq $errima){
                $Oinak{$oina}++;
            }
        }
        
        
        foreach my $o (@hitzak){
            if (exists($Oinak{$o})){
                print (FITXOUT2 "$Oinak{$o},");
            }else{
                print (FITXOUT2 "0,");
            }
        }
        
        print (FITXOUT2 "$data2->{Bertsolaria}->{$i}->{Izena}\n");
        
    }
    
    
    
    foreach my $bertso (@{$data3->{Bertsolaria}->{$i}->{Transkripzioa}->{lg}})
    {
        my %errimak_bertsoko = ();
        my ($errima, $hitza, $oina);
        my %Oinak = ();
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{content} =~ m/\w/){
                    $hitza = $lerro->{w}->{content};
                    $hitza =~ s/[\.,;:!\?\"\']//;
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($hitz->{content} =~ m/\w/){
                        $hitza = $hitz->{content};
                        $hitza =~ s/[\.,;:!\?\"\']//;
                    }
                }
            }
            $oina = $hitza;
            $errimak_bertsoko{errima_atera($oina)}++;
        }
        
        #gehien errepikatzen dena da bertsoko errima
        my @err = sort{$errimak_bertsoko{$b} <=> $errimak_bertsoko{$a}} keys(%errimak_bertsoko);
        $errima = $err[0];
        
        
        foreach my $lerro (@{$bertso->{l}}){
            if (ref($lerro->{w}) ne 'ARRAY'){
                if ($lerro->{w}->{content} =~ m/\w/){
                    $hitza = $lerro->{w}->{content};
                    $hitza =~ s/[\.,;:!\?\"\']//;
                }
            }else{
                foreach my $hitz (@{$lerro->{w}}){
                    if ($hitz->{content} =~ m/\w/){
                        $hitza = $hitz->{content};
                        $hitza =~ s/[\.,;:!\?\"\']//;
                    }
                }
            }
            $oina = $hitza;
            if (errima_atera($oina) eq $errima){
                $Oinak{$oina}++;
            }
        }
        
        
        foreach my $o (@hitzak){
            if (exists($Oinak{$o})){
                print (FITXOUT3 "$Oinak{$o},");
            }else{
                print (FITXOUT3 "0,");
            }
        }
        
        print (FITXOUT3 "$data3->{Bertsolaria}->{$i}->{Izena}\n");
        
    }
}

close(FITXOUT1);
close(FITXOUT2);
close(FITXOUT3);
close(Reader); close(Writer);




#oina emanda errima ateratzeko funtzioa
sub errima_atera {
    
    my $sarrera = shift();
    $sarrera = $sarrera."\n";
    
    print Writer $sarrera;
    
    my ($luz, $luzeena);
    $luz = 0;
    
    while ((my $returnword = <Reader>) ne "\n") {
        chomp($returnword);
        if ($luz < length ($returnword)) {
            $luz = length ($returnword);
            $luzeena = $returnword;
        }
    }
        
    return $luzeena;
}






